	.module InterComm.c
	.area text(rom, con, rel)
	.dbfile C:\DATA\InterComm\CODENE~1\InterComm.c
	.area lit(rom, con, rel)
_SineTable::
	.byte 133,136
	.byte 139,142
	.byte 145,149
	.byte 152,155
	.byte 158,161
	.byte 164,167
	.byte 169,172
	.byte 175,178
	.byte 181,184
	.byte 186,189
	.byte 192,194
	.byte 197,200
	.byte 202,205
	.byte 207,209
	.byte 212,214
	.byte 216,218
	.byte 220,222
	.byte 224,226
	.byte 228,230
	.byte 232,233
	.byte 235,237
	.byte 238,240
	.byte 241,242
	.byte 243,245
	.byte 246,247
	.byte 248,248
	.byte 249,250
	.byte 251,251
	.byte 252,252
	.byte 252,253
	.byte 253,253
	.byte 253,253
	.byte 253,253
	.byte 252,252
	.byte 252,251
	.byte 251,250
	.byte 249,248
	.byte 248,247
	.byte 246,245
	.byte 243,242
	.byte 241,240
	.byte 238,237
	.byte 235,233
	.byte 232,230
	.byte 228,226
	.byte 224,222
	.byte 220,218
	.byte 216,214
	.byte 212,209
	.byte 207,205
	.byte 202,200
	.byte 197,194
	.byte 192,189
	.byte 186,184
	.byte 181,178
	.byte 175,172
	.byte 169,167
	.byte 164,161
	.byte 158,155
	.byte 152,149
	.byte 145,142
	.byte 139,136
	.byte 133,130
	.byte 127,124
	.byte 'y,'v
	.byte 's,'p
	.byte 'm,'i
	.byte 'f,'c
	.byte 96,93
	.byte 'Z,'W
	.byte 'U,'R
	.byte 'O,'L
	.byte 'I,'F
	.byte 'D,'A
	.byte 62,60
	.byte 57,54
	.byte 52,49
	.byte 47,45
	.byte 42,40
	.byte 38,36
	.byte 34,32
	.byte 30,28
	.byte 26,24
	.byte 22,21
	.byte 19,17
	.byte 16,14
	.byte 13,12
	.byte 11,9
	.byte 8,7
	.byte 6,6
	.byte 5,4
	.byte 3,3
	.byte 2,2
	.byte 2,1
	.byte 1,1
	.byte 1,1
	.byte 1,1
	.byte 2,2
	.byte 2,3
	.byte 3,4
	.byte 5,6
	.byte 6,7
	.byte 8,9
	.byte 11,12
	.byte 13,14
	.byte 16,17
	.byte 19,21
	.byte 22,24
	.byte 26,28
	.byte 30,32
	.byte 34,36
	.byte 38,40
	.byte 42,45
	.byte 47,49
	.byte 52,54
	.byte 57,60
	.byte 62,'A
	.byte 'D,'F
	.byte 'I,'L
	.byte 'O,'R
	.byte 'U,'W
	.byte 'Z,93
	.byte 96,'c
	.byte 'f,'i
	.byte 'm,'p
	.byte 's,'v
	.byte 'y,124
	.byte 127,127
	.dbsym e SineTable _SineTable A[256:256]kc
	.area data(ram, con, rel)
	.dbfile C:\DATA\InterComm\CODENE~1\InterComm.c
_Volume::
	.blkb 1
	.area idata
	.byte 128
	.area data(ram, con, rel)
	.dbfile C:\DATA\InterComm\CODENE~1\InterComm.c
	.dbsym e Volume _Volume c
_Tone::
	.blkb 1
	.area idata
	.byte 8
	.area data(ram, con, rel)
	.dbfile C:\DATA\InterComm\CODENE~1\InterComm.c
	.dbsym e Tone _Tone c
	.area text(rom, con, rel)
	.dbfile C:\DATA\InterComm\CODENE~1\InterComm.c
	.dbfunc e main _main fV
	.even
_main::
	sbiw R28,2
	.dbline -1
	.dbline 356
; //*****************************************************************************
; // InterComm
; // Version 1.0 Sep 2005
; //
; // 1.0 -> -Everything is new
; //
; // Sylvain Bissonnette
; //*****************************************************************************
; // Editor : UltraEdit32
; //*****************************************************************************
; //
; //                    R E T U R N   S T A C K   3 2
; //                          X T A L  16 MHZ
; //                      BootLoader of 1024 word
; //
; //*****************************************************************************
; //
; //                          F U S E   B I T
; //
; //( )7      ( )6     ( )BL12 ( )BL11  ( )BL02   ( )BL01    ( )Lock2   ( )Lock1
; //( )7      ( )6     ( )     ( )      ( )       ( )M103C   ( )WDTON   ( )
; //( )OCDEN  ( )JTAGE (X)SPIEN(X)CKOPT (X)EESAVE ( )BOOTSZ1 (X)BOOTSZ0 (X)BOOTRST
; //(X)BODLEV (X)BODEN ( )SUT1 (X)SUT0  ( )CKSEL3 (X)CKSEL2  ( )CKSEL1  ( )CKSEL0
; //
; //*****************************************************************************
; //                          P I N   U S A G E
; //
; // PA0 -> GND
; // PA1 -> A/D input from Microphone
; // PA2 -> GND
; // PA3 -> GND
; // PA4 -> GND
; // PA5 -> GND
; // PA6 -> GND
; // PA7 -> GND
; //
; // PB0 -> Keypad ROW1
; // PB1 -> Keypad ROW2 
; // PB2 -> Keypad ROW3
; // PB3 -> Keypad ROW3
; // PB4 -> Keypad COL1
; // PB5 -> Keypad COL2
; // PB6 -> Keypad COL3
; // PB7 -> Keypad COL4
; //
; // PC0 -> LCD DB7
; // PC1 -> LCD DB6
; // PC2 -> LCD DB5
; // PC3 -> LCD DB4
; // PC4 -> LCD E
; // PC5 -> LCD R/W
; // PC6 -> LCD RS
; // PC7 -> LCD BackLight
; //
; // PD0 -> Net_RX
; // PD1 -> Net_TX
; // PD2 -> +5
; // PD3 -> LED
; // PD4 -> PWM Volume
; // PD5 -> PWM Voice
; // PD6 -> Ampli Standby
; // PD7 -> LCD Contrast
; //
; //*****************************************************************************
; //                        T I M E R   U S A G E
; //
; // Timer 0 is use for 20khz sampling & reproducing voice
; // Timer 1 is use for 62.5khz PWM voice reproducing and volume
; // Timer 2 is use for LCD Contrast
; // Timer 3 not use
; //
; //*****************************************************************************
; 
; //*****************************************************************************
; //                            I N C L U D E
; //*****************************************************************************
; #include <iom32v.h>
; #include <shortnametype.h>
; #include <macros.h>
; #include <stdlib.h>
; #include <stdio.h>
; #include <string.h>
; #include <eeprom.h>
; 
; //*****************************************************************************
; //                            D E F I N E
; //*****************************************************************************
; #define VERSION                 10
; #define TRUE                    1
; #define FALSE                   0
; #define XTAL                    16000000
; #define VERSIONTEXT							"  InterComm  V:2.1\0"
; 
; #define VOICEBUFFER             64
; 
; #define OFF                     0
; #define TALK                    1
; #define LISTEN                  2
; #define TONE                    3
; #define BUSY                    4
; 
; #define PWM_VOICE               0x20
; #define PWM_VOLUME              0x10
; #define AMPLI_STANDBY           0x40
; 
; #define EEPROM_VOLUME           1
; #define EEPROM_ADDRESS          2
; #define EEPROM_KEYSOUND         3
; #define EEPROM_KEYSOUNDVOLUME   4
; #define EEPROM_KEYSOUNDTONE     5
; #define EEPROM_KEYSOUNDLEN      6
; #define EEPROM_BROADCAST        7
; 
; #define LED                     0x08
; 
; #define MAXITEM                 20
; 
; // Network
; #define NET_DDR                 DDRD
; #define NET_PIN                 PIND
; #define NET_PORT                PORTD
; #define NET_RX                  0x01
; #define NET_TX                  0x02
; 
; #define NET_UBRRH               UBRRH
; #define NET_UBRRL               UBRRL
; #define NET_UCSRA               UCSRA
; #define NET_UCSRB               UCSRB
; #define NET_UCSRC               UCSRC
; #define NET_UDR                 UDR
; 
; #define NET_SPEED               500000
; #define NET_GET_ADDRESS         EEPROMread(EEPROM_ADDRESS);
; 
; // LCD
; #define LCD_D7                  0x01
; #define LCD_D6                  0x02
; #define LCD_D5                  0x04
; #define LCD_D4                  0x08
; #define LCD_E                   0x10
; #define LCD_RW                  0x20
; #define LCD_RS                  0x40
; #define LCD_BACKLIGHT           0x80
;                                 
; #define LCD_PIN                 PINC
; #define LCD_DDR                 DDRC
; #define LCD_PORT                PORTC
;                                 
; #define LCD_DATA                0x01
; #define LCD_CTRL                0x00
;                                 
; #define LCD_C_BLINK_ON          0x09
; #define LCD_C_BLINK_OFF         0xfe
; #define LCD_C_ON                0x0a
; #define LCD_C_OFF               0xfd
; #define LCD_DISPLAY_ON          0x0c
; #define LCD_DISPLAY_OFF         0xfb
; #define LCD_BRIGHT_25           0x23
; #define LCD_BRIGHT_50           0x22
; #define LCD_BRIGHT_75           0x21
; #define LCD_BRIGHT_100          0x20
; #define LCD_BACKLIGHT_ON        0x24
; #define LCD_BACKLIGHT_OFF       0x25
; 
; // Key
; #define KEY_PIN                 PINB
; #define KEY_DDR                 DDRB
; #define KEY_PORT                PORTB
;                                 
; // Keypad
; #define ROW1                    0x02
; #define ROW2		                0x04
; #define ROW3 		                0x08
; #define ROW4		                0x10
; #define COL1 		                0x20
; #define COL2		                0x40
; #define COL3		                0x80
; #define COL4		                0x80
; 
; #define RESET                   20
; 
; //*****************************************************************************
; //           C O N S T A N T			 				               
; //*****************************************************************************
; // SineTable
; const ushort SineTable[256] =	 {133,136,139,142,
; 	  		   					   	        145,149,152,155,
; 									              158,161,164,167,
; 									              169,172,175,178,
; 									              181,184,186,189,
;                   						  192,194,197,200,
;                   						  202,205,207,209,
;                   						  212,214,216,218,
;                   						  220,222,224,226,
;                   						  228,230,232,233,
;                   						  235,237,238,240,
;                   						  241,242,243,245,
;                   						  246,247,248,248,
;                   						  249,250,251,251,
;                   						  252,252,252,253,
;                   						  253,253,253,253,
;                   						  253,253,252,252,
;                   						  252,251,251,250,
;                   						  249,248,248,247,
;                   						  246,245,243,242,
;                   						  241,240,238,237,
;                   						  235,233,232,230,
;                   						  228,226,224,222,
;                   						  220,218,216,214,
;                   						  212,209,207,205,
;                   						  202,200,197,194,
;                   						  192,189,186,184,
;                   						  181,178,175,172,
;                   						  169,167,164,161,
;                   						  158,155,152,149,
;                   						  145,142,139,136,
;                   						  133,130,127,124,
;                   						  121,118,115,112,
;                   						  109,105,102,99,
;                   						  96,93,90,87,
;                   						  85,82,79,76,
;                   						  73,70,68,65,
;                   						  62,60,57,54,
;                   						  52,49,47,45,
;                   						  42,40,38,36,
;                   						  34,32,30,28,
;                   						  26,24,22,21,
;                   						  19,17,16,14,
;                   						  13,12,11,9,
;                   						  8,7,6,6,
;                   						  5,4,3,3,
;                   						  2,2,2,1,
;                   						  1,1,1,1,
;                   						  1,1,2,2,
;                   						  2,3,3,4,
;                   						  5,6,6,7,
;                   						  8,9,11,12,
;                   						  13,14,16,17,
;                   						  19,21,22,24,
;                   						  26,28,30,32,
;                   						  34,36,38,40,
;                   						  42,45,47,49,
;                   						  52,54,57,60,
;                   						  62,65,68,70,
;                   						  73,76,79,82,
;                   						  85,87,90,93,
;                   						  96,99,102,105,
;                   						  109,112,115,118,
;                   						  121,124,127,127};
; 	
; //*****************************************************************************
; //                            P R O T O T Y P E
; //*****************************************************************************
; void main(void);
; void DoVolume(void);
; void DoKey(ushort ReGen);
; void DisplayInterComState(void);
; void SetKeySoundLen(void);
; void SetKeySoundTone(void);
; void SetKeySoundVolume(void);
; void SetKeySound(void);
; void SetBroadCastEnable(void);
; void SetStationAddress(void);
; void StationCall(ushort Station);
; void BroadCastCall(void);
; void SendRelease(void);
; void _StackOverflowed(char c);
; void Led(void);
; void Info(void);
; void Delay(ushort Del);
; 
; // A/D
; void ADInit(void);
; void ADStart(void);
; void ADDone(void);
; 
; // Voice
; void VoiceEnginInit(void);
; void VoiceEngin(void);
; void VoiceVolume(ushort Vol);
; 
; // Network
; void NetInit(void);
; void NetSendCommand(ushort To,ushort Command);
; void NetDirectWriteByte(ushort Byte);
; void NetWriteByte(ushort Byte);
; ushort NetReadByte(void);
; ushort NetGetInByteCount(void);
; void NetRxByte(void);
; void NetTxByte(void);
; void NetGetAddress(void);
; 
; // LCD
; void LCDInit(ushort x,ushort y);
; void LCDOff(void);
; void LCDClrSCR(void);
; void LCDGotoXY(ushort,ushort);
; ushort LCDWhereX(void);
; ushort LCDWhereY(void);
; void LCDWriteString(char *);
; void LCDWriteConstString(const char *);
; void LCDWriteChar(char);
; void LCDWriteData(ushort,ushort);
; ushort LCDReadData(ushort rs);
; void LCDCreateCHR(ushort chnumber, char *ptr);  
; void LCDWait(void);
; void LCDDelay50us(int Delay);
; void LCDTextAttr(ushort attribute);
; void LCDContrast(ushort Cont);
; 
; // Key
; void KeyInit(void);
; ushort KeyLook(void);
; void KeyScan(void);
; 
; //*****************************************************************************
; //                      G L O B A L   V A R I A B L E
; //*****************************************************************************
; 
; // LCD
; ushort MaxX, MaxY, LCDStat;
; char Text[20];
; 
; // Keypad
; ushort Key;
; ushort KeySound;
; ushort KeySoundVolume;
; ushort KeySoundTone;
; ushort KeySoundLen;
; 
; // Network
; ushort  NetAddress;
; ushort DataInBuffer[VOICEBUFFER];
; ushort *DataInBufferWrite;
; ushort *DataInBufferRead;
; uint DataInBufferQte;
; 
; ushort DataOutBuffer[VOICEBUFFER];
; ushort *DataOutBufferWrite;
; ushort *DataOutBufferRead;
; uint DataOutBufferQte;
; 
; ushort InterCommMode;
; ushort IncommingCall;
; ushort Volume = 0x80;
; ushort Tone = 8;
; 
; // Others
; ushort BroadCastEnable;
; ushort RefreshDisplay;
; 
; //*****************************************************************************
; //                      M A I N
; //*****************************************************************************
; void main()
; {
	.dbline 357
;   WDR();
	wdr
	.dbline 358
;   WDTCR = 0x0f; // Watch Dog enable
	ldi R24,15
	out 0x21,R24
	.dbline 359
;   LCDInit(20,2);
	ldi R18,2
	ldi R16,20
	xcall _LCDInit
	.dbline 360
;   KeyInit();
	xcall _KeyInit
	.dbline 361
;   NetInit();
	xcall _NetInit
	.dbline 362
;   ADInit();
	xcall _ADInit
	.dbline 363
;   VoiceEnginInit();
	xcall _VoiceEnginInit
	.dbline 365
; 
;   SEI(); //re-enable interrupts
	sei
	.dbline 367
; 
;   EEPROM_READ(EEPROM_VOLUME, Volume);
	ldi R24,1
	ldi R25,0
	std y+1,R25
	std y+0,R24
	ldi R18,<_Volume
	ldi R19,>_Volume
	ldi R16,1
	ldi R17,0
	xcall _EEPROMReadBytes
	.dbline 368
;   EEPROM_READ(EEPROM_KEYSOUND, KeySound);
	ldi R24,1
	ldi R25,0
	std y+1,R25
	std y+0,R24
	ldi R18,<_KeySound
	ldi R19,>_KeySound
	ldi R16,3
	ldi R17,0
	xcall _EEPROMReadBytes
	.dbline 369
;   EEPROM_READ(EEPROM_KEYSOUNDVOLUME, KeySoundVolume);
	ldi R24,1
	ldi R25,0
	std y+1,R25
	std y+0,R24
	ldi R18,<_KeySoundVolume
	ldi R19,>_KeySoundVolume
	ldi R16,4
	ldi R17,0
	xcall _EEPROMReadBytes
	.dbline 370
;   EEPROM_READ(EEPROM_KEYSOUNDTONE, KeySoundTone);
	ldi R24,1
	ldi R25,0
	std y+1,R25
	std y+0,R24
	ldi R18,<_KeySoundTone
	ldi R19,>_KeySoundTone
	ldi R16,5
	ldi R17,0
	xcall _EEPROMReadBytes
	.dbline 371
;   EEPROM_READ(EEPROM_KEYSOUNDLEN, KeySoundLen);
	ldi R24,1
	ldi R25,0
	std y+1,R25
	std y+0,R24
	ldi R18,<_KeySoundLen
	ldi R19,>_KeySoundLen
	ldi R16,6
	ldi R17,0
	xcall _EEPROMReadBytes
	.dbline 372
;   EEPROM_READ(EEPROM_BROADCAST, BroadCastEnable);
	ldi R24,1
	ldi R25,0
	std y+1,R25
	std y+0,R24
	ldi R18,<_BroadCastEnable
	ldi R19,>_BroadCastEnable
	ldi R16,7
	ldi R17,0
	xcall _EEPROMReadBytes
	.dbline 374
;   
;   if (KeySoundTone > 59) KeySoundTone = 59;
	ldi R24,59
	lds R2,_KeySoundTone
	cp R24,R2
	brsh L2
X0:
	.dbline 374
	sts _KeySoundTone,R24
L2:
	.dbline 375
;   if (KeySoundLen > 10) KeySoundLen = 10;
	ldi R24,10
	lds R2,_KeySoundLen
	cp R24,R2
	brsh L4
X1:
	.dbline 375
	sts _KeySoundLen,R24
L4:
	.dbline 377
; 
;   Info();
	xcall _Info
	.dbline 378
;   InterCommMode = TONE;
	ldi R24,3
	sts _InterCommMode,R24
	.dbline 379
;   VoiceVolume(0x40);  
	ldi R16,64
	xcall _VoiceVolume
	.dbline 380
;   Delay(50);
	ldi R16,50
	xcall _Delay
	.dbline 381
;   LCDClrSCR();
	xcall _LCDClrSCR
	.dbline 382
;   VoiceVolume(0);
	clr R16
	xcall _VoiceVolume
	.dbline 383
;   InterCommMode = OFF;
	clr R2
	sts _InterCommMode,R2
	.dbline 384
;   IncommingCall = FALSE;
	sts _IncommingCall,R2
	.dbline 385
;   DoKey(TRUE);
	ldi R16,1
	xcall _DoKey
	xjmp L7
L6:
	.dbline 388
; 
;   while(1)
;   {
	.dbline 389
;     WDR();
	wdr
	.dbline 390
;     _StackCheck();
	xcall __StackCheck
	.dbline 392
;     
;     if (KeyLook() == RESET) while(TRUE);
	xcall _KeyLook
	cpi R16,20
	brne L9
X2:
L11:
	.dbline 392
L12:
	.dbline 392
	xjmp L11
L9:
	.dbline 393
;     if ((!IncommingCall) && (InterCommMode != BUSY)) DoKey(FALSE);
	lds R2,_IncommingCall
	tst R2
	brne L14
X3:
	lds R24,_InterCommMode
	cpi R24,4
	breq L14
X4:
	.dbline 393
	clr R16
	xcall _DoKey
L14:
	.dbline 394
;     if (IncommingCall) DoVolume();
	lds R2,_IncommingCall
	tst R2
	breq L16
X5:
	.dbline 394
	xcall _DoVolume
L16:
	.dbline 395
;     if (InterCommMode == BUSY) DisplayInterComState();
	lds R24,_InterCommMode
	cpi R24,4
	brne L18
X6:
	.dbline 395
	xcall _DisplayInterComState
L18:
	.dbline 396
;   }
L7:
	.dbline 387
	xjmp L6
X7:
	.dbline -2
L1:
	.dbline 0 ; func end
	adiw R28,2
	ret
	.dbend
	.area bss(ram, con, rel)
	.dbfile C:\DATA\InterComm\CODENE~1\InterComm.c
L21:
	.blkb 2
	.area data(ram, con, rel)
	.dbfile C:\DATA\InterComm\CODENE~1\InterComm.c
L22:
	.blkb 2
	.area idata
	.word 0
	.area data(ram, con, rel)
	.dbfile C:\DATA\InterComm\CODENE~1\InterComm.c
	.area text(rom, con, rel)
	.dbfile C:\DATA\InterComm\CODENE~1\InterComm.c
	.dbfunc e DoVolume _DoVolume fV
	.dbsym s VolumeChange L22 I
	.dbsym s Ticker L21 I
	.even
_DoVolume::
	sbiw R28,2
	.dbline -1
	.dbline 413
; }
; 
; /******************************************************************************
; 
; Name:			void DoKey(void)
; 
; Description:	
; 
; Input:			none
; 
; Output:			none
; 
; Misc:			
; 
; ******************************************************************************/
; void DoVolume(void)
; {
	.dbline 416
;   static int Ticker,VolumeChange=FALSE;
; 
;   DisplayInterComState();
	xcall _DisplayInterComState
	.dbline 418
; 
;   Ticker++;
	lds R24,L21
	lds R25,L21+1
	adiw R24,1
	sts L21+1,R25
	sts L21,R24
	.dbline 419
;   Key = KeyLook();
	xcall _KeyLook
	sts _Key,R16
	.dbline 421
; 
;   if ((Key == 11) && (Volume < 255)) Volume++;
	cpi R16,11
	brne L23
X8:
	lds R24,_Volume
	cpi R24,255
	brsh L23
X9:
	.dbline 421
	subi R24,255    ; addi 1
	sts _Volume,R24
L23:
	.dbline 422
;   if ((Key == 10) &&(Volume > 1)) Volume--;
	lds R24,_Key
	cpi R24,10
	brne L25
X10:
	ldi R24,1
	lds R2,_Volume
	cp R24,R2
	brsh L25
X11:
	.dbline 422
	mov R24,R2
	subi R24,1
	sts _Volume,R24
L25:
	.dbline 424
; 
;   if (Key != 0xff)
	lds R24,_Key
	cpi R24,255
	breq L27
X12:
	.dbline 425
;   {
	.dbline 426
;     if (Key == 8) 
	cpi R24,8
	brne L29
X13:
	.dbline 427
;     {
	.dbline 428
;     	InterCommMode = OFF;
	clr R2
	sts _InterCommMode,R2
	.dbline 429
;   		IncommingCall = FALSE;
	sts _IncommingCall,R2
	.dbline 430
;     }
L29:
	.dbline 431
;     Ticker = 0;
	clr R2
	clr R3
	sts L21+1,R3
	sts L21,R2
	.dbline 432
;     VoiceVolume(Volume);
	lds R16,_Volume
	xcall _VoiceVolume
	.dbline 433
;     VolumeChange = TRUE;
	ldi R24,1
	ldi R25,0
	sts L22+1,R25
	sts L22,R24
	.dbline 434
;     LCDGotoXY(1,2);
	ldi R18,2
	ldi R16,1
	xcall _LCDGotoXY
	.dbline 435
;     LCDWriteConstString("                    \0");
	ldi R16,<L31
	ldi R17,>L31
	xcall _LCDWriteConstString
	.dbline 436
;     LCDGotoXY(1,2);
	ldi R18,2
	ldi R16,1
	xcall _LCDGotoXY
	.dbline 437
;     csprintf(&Text[0],"    Volume :%d  \0",Volume);
	lds R2,_Volume
	clr R3
	std y+1,R3
	std y+0,R2
	ldi R18,<L32
	ldi R19,>L32
	ldi R16,<_Text
	ldi R17,>_Text
	xcall _csprintf
	.dbline 438
;     LCDWriteString(&Text[0]);
	ldi R16,<_Text
	ldi R17,>_Text
	xcall _LCDWriteString
	.dbline 439
;     Delay(1);
	ldi R16,1
	xcall _Delay
	.dbline 440
;     Key = 0xff;
	ldi R24,255
	sts _Key,R24
	.dbline 441
;   }
L27:
	.dbline 443
; 
;   if ((VolumeChange == TRUE) && (Ticker > 1000))
	lds R24,L22
	lds R25,L22+1
	cpi R24,1
	ldi R30,0
	cpc R25,R30
	brne L33
X14:
	ldi R24,1000
	ldi R25,3
	lds R2,L21
	lds R3,L21+1
	cp R24,R2
	cpc R25,R3
	brge L33
X15:
	.dbline 444
;   {
	.dbline 445
;     EEPROM_WRITE(EEPROM_VOLUME, Volume);
	ldi R24,1
	ldi R25,0
	std y+1,R25
	std y+0,R24
	ldi R18,<_Volume
	ldi R19,>_Volume
	ldi R16,1
	ldi R17,0
	xcall _EEPROMWriteBytes
	.dbline 446
;     VolumeChange = FALSE;
	clr R2
	clr R3
	sts L22+1,R3
	sts L22,R2
	.dbline 447
;   }
L33:
	.dbline -2
L20:
	.dbline 0 ; func end
	adiw R28,2
	ret
	.dbend
	.area bss(ram, con, rel)
	.dbfile C:\DATA\InterComm\CODENE~1\InterComm.c
L36:
	.blkb 1
L37:
	.blkb 1
L38:
	.blkb 1
L39:
	.blkb 1
	.area text(rom, con, rel)
	.dbfile C:\DATA\InterComm\CODENE~1\InterComm.c
	.dbfunc e DoKey _DoKey fV
	.dbsym s Update L39 c
	.dbsym s Value L38 c
	.dbsym s KeySecond L37 c
	.dbsym s KeyFirst L36 c
;          ReGen -> R10
	.even
_DoKey::
	xcall push_xgset300C
	mov R10,R16
	.dbline -1
	.dbline 464
; }
; 
; /******************************************************************************
; 
; Name:			void DoKey(void)
; 
; Description:	
; 
; Input:			none
; 
; Output:			none
; 
; Misc:			
; 
; ******************************************************************************/
; void DoKey(ushort ReGen)
; {
	.dbline 467
;   static ushort KeyFirst,KeySecond,Value,Update;
; 
;   Update = FALSE;
	clr R2
	sts L39,R2
	.dbline 469
; 
;   DisplayInterComState();
	xcall _DisplayInterComState
	.dbline 471
; 
;   if (ReGen)
	tst R10
	breq L40
X16:
	.dbline 472
;   {
	.dbline 473
;     LCDClrSCR();
	xcall _LCDClrSCR
	.dbline 474
;     LCDGotoXY(1,1);
	ldi R18,1
	ldi R16,1
	xcall _LCDGotoXY
	.dbline 475
;     LCDWriteConstString(VERSIONTEXT);
	ldi R16,<L42
	ldi R17,>L42
	xcall _LCDWriteConstString
	.dbline 476
;     LCDGotoXY(1,2);
	ldi R18,2
	ldi R16,1
	xcall _LCDGotoXY
	.dbline 477
;     LCDWriteData(LCD_DATA,KeySecond+48);
	lds R18,L37
	subi R18,208    ; addi 48
	ldi R16,1
	xcall _LCDWriteData
	.dbline 478
;     LCDWriteData(LCD_DATA,KeyFirst+48);
	lds R18,L36
	subi R18,208    ; addi 48
	ldi R16,1
	xcall _LCDWriteData
	.dbline 479
;     Value = (KeySecond * 10) + KeyFirst;
	lds R2,L37
	ldi R24,10
	mul R24,R2
	lds R2,L36
	mov R3,R0
	add R3,R2
	sts L38,R3
	.dbline 480
;     Update = TRUE;
	ldi R24,1
	sts L39,R24
	.dbline 481
;   }
	xjmp L41
L40:
	.dbline 483
;   else
;   {
	.dbline 484
;     KeyScan();
	xcall _KeyScan
	.dbline 486
; 
;     if ((Key != 0xff) && (Key != 10) && (Key != 11))
	lds R2,_Key
	mov R24,R2
	cpi R24,255
	breq L43
X17:
	cpi R24,10
	breq L43
X18:
	cpi R24,11
	breq L43
X19:
	.dbline 487
;     {
	.dbline 488
;       KeySecond = KeyFirst;
	lds R2,L36
	sts L37,R2
	.dbline 489
;       KeyFirst = Key;
	mov R2,R24
	sts L36,R2
	.dbline 490
;       LCDGotoXY(1,2);
	ldi R18,2
	ldi R16,1
	xcall _LCDGotoXY
	.dbline 491
;       LCDWriteData(LCD_DATA,KeySecond+48);
	lds R18,L37
	subi R18,208    ; addi 48
	ldi R16,1
	xcall _LCDWriteData
	.dbline 492
;       LCDWriteData(LCD_DATA,KeyFirst+48);
	lds R18,L36
	subi R18,208    ; addi 48
	ldi R16,1
	xcall _LCDWriteData
	.dbline 493
;       Value = (KeySecond * 10) + KeyFirst;
	lds R2,L37
	ldi R24,10
	mul R24,R2
	lds R2,L36
	mov R3,R0
	add R3,R2
	sts L38,R3
	.dbline 494
;       Update = TRUE;
	ldi R24,1
	sts L39,R24
	.dbline 495
;       Key = 0xff;
	ldi R24,255
	sts _Key,R24
	.dbline 496
;     }
L43:
	.dbline 497
;   }
L41:
	.dbline 501
; 
; //--------------------
; 
;   if (Update == TRUE)
	lds R24,L39
	cpi R24,1
	breq X46
	xjmp L45
X46:
X20:
	.dbline 502
;   {
	.dbline 503
;     LCDGotoXY(3,2);
	ldi R18,2
	ldi R16,3
	xcall _LCDGotoXY
	.dbline 504
;     if (Value == 0) LCDWriteConstString("->Broadcast Call #\0");
	lds R2,L38
	tst R2
	brne L47
X21:
	.dbline 504
	ldi R16,<L49
	ldi R17,>L49
	xcall _LCDWriteConstString
	xjmp L48
L47:
	.dbline 505
;     else if ((Value >= 1) && (Value < 40)) LCDWriteConstString("->Calling #       \0");
	lds R2,L38
	mov R24,R2
	cpi R24,1
	brlo L50
X22:
	cpi R24,40
	brsh L50
X23:
	.dbline 505
	ldi R16,<L52
	ldi R17,>L52
	xcall _LCDWriteConstString
	xjmp L51
L50:
	.dbline 506
;     else if (Value == 88) LCDWriteConstString("->Send Release #  \0");
	lds R24,L38
	cpi R24,88
	brne L53
X24:
	.dbline 506
	ldi R16,<L55
	ldi R17,>L55
	xcall _LCDWriteConstString
	xjmp L54
L53:
	.dbline 507
;     else if (Value == 99) LCDWriteConstString("->Set Address #   \0");
	lds R24,L38
	cpi R24,99
	brne L56
X25:
	.dbline 507
	ldi R16,<L58
	ldi R17,>L58
	xcall _LCDWriteConstString
	xjmp L57
L56:
	.dbline 508
;     else if (Value == 98) LCDWriteConstString("->Set Key Sound # \0");
	lds R24,L38
	cpi R24,98
	brne L59
X26:
	.dbline 508
	ldi R16,<L61
	ldi R17,>L61
	xcall _LCDWriteConstString
	xjmp L60
L59:
	.dbline 509
;     else if (Value == 97) LCDWriteConstString("->Set Key Tone # \0 ");
	lds R24,L38
	cpi R24,97
	brne L62
X27:
	.dbline 509
	ldi R16,<L64
	ldi R17,>L64
	xcall _LCDWriteConstString
	xjmp L63
L62:
	.dbline 510
;     else if (Value == 96) LCDWriteConstString("->Set Key Volume #\0");
	lds R24,L38
	cpi R24,96
	brne L65
X28:
	.dbline 510
	ldi R16,<L67
	ldi R17,>L67
	xcall _LCDWriteConstString
	xjmp L66
L65:
	.dbline 511
;     else if (Value == 95) LCDWriteConstString("->Set Tone Len # \0");
	lds R24,L38
	cpi R24,95
	brne L68
X29:
	.dbline 511
	ldi R16,<L70
	ldi R17,>L70
	xcall _LCDWriteConstString
	xjmp L69
L68:
	.dbline 512
;     else if (Value == 94) LCDWriteConstString("->Set BroadCast # \0");
	lds R24,L38
	cpi R24,94
	brne L71
X30:
	.dbline 512
	ldi R16,<L73
	ldi R17,>L73
	xcall _LCDWriteConstString
	xjmp L72
L71:
	.dbline 513
;     else if (Value == 93) LCDWriteConstString("->Reset Station # \0");
	lds R24,L38
	cpi R24,93
	brne L74
X31:
	.dbline 513
	ldi R16,<L76
	ldi R17,>L76
	xcall _LCDWriteConstString
	xjmp L75
L74:
	.dbline 514
;     else if ((Value >= 40) && (Value < 94)) LCDWriteConstString("->                \0");
	lds R20,L38
	cpi R20,40
	brlo L77
X32:
	cpi R20,94
	brsh L77
X33:
	.dbline 514
	ldi R16,<L79
	ldi R17,>L79
	xcall _LCDWriteConstString
L77:
L75:
L72:
L69:
L66:
L63:
L60:
L57:
L54:
L51:
L48:
	.dbline 515
;   }
L45:
	.dbline 519
; 
; //--------------------
; 
;   if (Key == 11)
	lds R24,_Key
	cpi R24,11
	breq X47
	xjmp L80
X47:
X34:
	.dbline 520
;   {
	.dbline 521
;     Key = 0xff;
	ldi R24,255
	sts _Key,R24
	.dbline 522
;     if (Value == 0) BroadCastCall();
	lds R2,L38
	tst R2
	brne L82
X35:
	.dbline 522
	xcall _BroadCastCall
	xjmp L83
L82:
	.dbline 523
;     else if ((Value >= 0) && (Value < 40)) StationCall(Value);
	lds R20,L38
	cpi R20,0
	brlo L84
X36:
	cpi R20,40
	brsh L84
X37:
	.dbline 523
	mov R16,R20
	xcall _StationCall
	xjmp L85
L84:
	.dbline 524
;     else if (Value == 88) SendRelease();
	lds R24,L38
	cpi R24,88
	brne L86
X38:
	.dbline 524
	xcall _SendRelease
	xjmp L87
L86:
	.dbline 525
;     else if (Value == 99) SetStationAddress();
	lds R24,L38
	cpi R24,99
	brne L88
X39:
	.dbline 525
	xcall _SetStationAddress
	xjmp L89
L88:
	.dbline 526
;     else if (Value == 98) SetKeySound();
	lds R24,L38
	cpi R24,98
	brne L90
X40:
	.dbline 526
	xcall _SetKeySound
	xjmp L91
L90:
	.dbline 527
;     else if (Value == 97) SetKeySoundTone();
	lds R24,L38
	cpi R24,97
	brne L92
X41:
	.dbline 527
	xcall _SetKeySoundTone
	xjmp L93
L92:
	.dbline 528
;     else if (Value == 96) SetKeySoundVolume();
	lds R24,L38
	cpi R24,96
	brne L94
X42:
	.dbline 528
	xcall _SetKeySoundVolume
	xjmp L95
L94:
	.dbline 529
;     else if (Value == 95) SetKeySoundLen();
	lds R24,L38
	cpi R24,95
	brne L96
X43:
	.dbline 529
	xcall _SetKeySoundLen
	xjmp L97
L96:
	.dbline 530
;     else if (Value == 94) SetBroadCastEnable();
	lds R24,L38
	cpi R24,94
	brne L98
X44:
	.dbline 530
	xcall _SetBroadCastEnable
	xjmp L99
L98:
	.dbline 531
;   	else if (Value == 93) {CLI(); while(TRUE);}
	lds R24,L38
	cpi R24,93
	brne L100
X45:
	.dbline 531
	.dbline 531
	cli
L102:
	.dbline 531
L103:
	.dbline 531
	xjmp L102
L100:
L99:
L97:
L95:
L93:
L91:
L89:
L87:
L85:
L83:
	.dbline 532
;   }
L80:
	.dbline -2
L35:
	.dbline 0 ; func end
	xjmp pop_xgset300C
	.dbsym r ReGen 10 c
	.dbend
	.area bss(ram, con, rel)
	.dbfile C:\DATA\InterComm\CODENE~1\InterComm.c
L106:
	.blkb 1
	.area text(rom, con, rel)
	.dbfile C:\DATA\InterComm\CODENE~1\InterComm.c
	.dbfunc e DisplayInterComState _DisplayInterComState fV
	.dbsym s LastIntercommMode L106 c
	.even
_DisplayInterComState::
	sbiw R28,2
	.dbline -1
	.dbline 549
; }
; 
; /******************************************************************************
; 
; Name:			  void DisplayInterComState(void)
; 
; Description:	
; 
; Input:			  none
; 
; Output:			  none
; 
; Misc:			
; 
; ******************************************************************************/
; void DisplayInterComState(void)
; {
	.dbline 552
;    static ushort LastIntercommMode;
; 
;    if (LastIntercommMode != InterCommMode)
	lds R2,_InterCommMode
	lds R3,L106
	cp R3,R2
	brne X52
	xjmp L107
X52:
X48:
	.dbline 553
;    {
	.dbline 554
;       LastIntercommMode = InterCommMode;
	sts L106,R2
	.dbline 555
;       if (LastIntercommMode == OFF)
	tst R2
	brne L109
X49:
	.dbline 556
;       {
	.dbline 557
;          LCDClrSCR();
	xcall _LCDClrSCR
	.dbline 558
;          LCDWriteConstString("Communication ended \0"); 
	ldi R16,<L111
	ldi R17,>L111
	xcall _LCDWriteConstString
	.dbline 559
;          Delay(75);
	ldi R16,75
	xcall _Delay
	.dbline 560
;          LCDGotoXY(1,1);
	ldi R18,1
	ldi R16,1
	xcall _LCDGotoXY
	.dbline 561
;          LCDWriteConstString("                    \0"); 
	ldi R16,<L31
	ldi R17,>L31
	xcall _LCDWriteConstString
	.dbline 562
; 	 			DoKey(TRUE);
	ldi R16,1
	xcall _DoKey
	.dbline 563
;       }
L109:
	.dbline 564
;      if (LastIntercommMode == BUSY)
	lds R24,L106
	cpi R24,4
	brne L112
X50:
	.dbline 565
;       {
	.dbline 566
;          LCDClrSCR();
	xcall _LCDClrSCR
	.dbline 567
;          LCDWriteConstString(" --    B u s y   -- \0");
	ldi R16,<L114
	ldi R17,>L114
	xcall _LCDWriteConstString
	.dbline 568
;          LCDGotoXY(1,2);
	ldi R18,2
	ldi R16,1
	xcall _LCDGotoXY
	.dbline 569
;          LCDWriteConstString(" --  Please Wait -- \0");
	ldi R16,<L115
	ldi R17,>L115
	xcall _LCDWriteConstString
	.dbline 570
;       }
L112:
	.dbline 571
;      if (LastIntercommMode == TALK)
	lds R24,L106
	cpi R24,1
	brne L116
X51:
	.dbline 572
;       {
	.dbline 573
;          LCDClrSCR();
	xcall _LCDClrSCR
	.dbline 574
;          LCDWriteConstString(" --Incomming Call-- \0");
	ldi R16,<L118
	ldi R17,>L118
	xcall _LCDWriteConstString
	.dbline 575
;          LCDGotoXY(1,2);
	ldi R18,2
	ldi R16,1
	xcall _LCDGotoXY
	.dbline 576
;          csprintf(&Text[0],"    Volume :%d  \0",Volume);
	lds R2,_Volume
	clr R3
	std y+1,R3
	std y+0,R2
	ldi R18,<L32
	ldi R19,>L32
	ldi R16,<_Text
	ldi R17,>_Text
	xcall _csprintf
	.dbline 577
;          LCDWriteString(&Text[0]);
	ldi R16,<_Text
	ldi R17,>_Text
	xcall _LCDWriteString
	.dbline 578
;       }
L116:
	.dbline 579
;    }
L107:
	.dbline -2
L105:
	.dbline 0 ; func end
	adiw R28,2
	ret
	.dbend
	.area bss(ram, con, rel)
	.dbfile C:\DATA\InterComm\CODENE~1\InterComm.c
L120:
	.blkb 1
L121:
	.blkb 1
L122:
	.blkb 1
	.area text(rom, con, rel)
	.dbfile C:\DATA\InterComm\CODENE~1\InterComm.c
	.dbfunc e SetKeySoundLen _SetKeySoundLen fV
	.dbsym s Value L122 c
	.dbsym s KeySecond L121 c
	.dbsym s KeyFirst L120 c
	.even
_SetKeySoundLen::
	sbiw R28,2
	.dbline -1
	.dbline 596
; }
; 
; /******************************************************************************
; 
; Name:			    SetKeySoundLen(void)
; 
; Description:	
; 
; Input:			  none
; 
; Output:			  none
; 
; Misc:			
; 
; ******************************************************************************/
; void SetKeySoundLen(void)
; {
	.dbline 599
;   static ushort KeyFirst,KeySecond,Value;
; 
;   LCDClrSCR();
	xcall _LCDClrSCR
	.dbline 600
;   LCDGotoXY(1,1);
	ldi R18,1
	ldi R16,1
	xcall _LCDGotoXY
	.dbline 601
;   csprintf(&Text[0],"Current Tone : %d\0",KeySoundLen);
	lds R2,_KeySoundLen
	clr R3
	std y+1,R3
	std y+0,R2
	ldi R18,<L123
	ldi R19,>L123
	ldi R16,<_Text
	ldi R17,>_Text
	xcall _csprintf
	.dbline 602
;   LCDWriteString(&Text[0]);
	ldi R16,<_Text
	ldi R17,>_Text
	xcall _LCDWriteString
	.dbline 603
;   LCDGotoXY(1,2);
	ldi R18,2
	ldi R16,1
	xcall _LCDGotoXY
	.dbline 604
;   LCDWriteConstString("New Tone(00-10):00\0");
	ldi R16,<L124
	ldi R17,>L124
	xcall _LCDWriteConstString
	xjmp L126
L125:
	.dbline 607
; 
;   while(TRUE)
;   {
	.dbline 608
;     WDR();
	wdr
	.dbline 609
;     KeyScan();
	xcall _KeyScan
	.dbline 610
;     if ((Key != 0xff) && (Key != 10) && (Key != 11))
	lds R2,_Key
	mov R24,R2
	cpi R24,255
	breq L128
X53:
	cpi R24,10
	breq L128
X54:
	cpi R24,11
	breq L128
X55:
	.dbline 611
;     {
	.dbline 612
;       KeySecond = KeyFirst;
	lds R2,L120
	sts L121,R2
	.dbline 613
;       KeyFirst = Key;
	mov R2,R24
	sts L120,R2
	.dbline 614
;       LCDGotoXY(17,2);
	ldi R18,2
	ldi R16,17
	xcall _LCDGotoXY
	.dbline 615
;       LCDWriteData(LCD_DATA,KeySecond+48);
	lds R18,L121
	subi R18,208    ; addi 48
	ldi R16,1
	xcall _LCDWriteData
	.dbline 616
;       LCDWriteData(LCD_DATA,KeyFirst+48);
	lds R18,L120
	subi R18,208    ; addi 48
	ldi R16,1
	xcall _LCDWriteData
	.dbline 617
;       Value = (KeySecond * 10) + KeyFirst;
	lds R2,L121
	ldi R24,10
	mul R24,R2
	lds R2,L120
	mov R3,R0
	add R3,R2
	sts L122,R3
	.dbline 618
;       if (Value < 11) KeySoundLen = Value;
	mov R24,R3
	cpi R24,11
	brsh L130
X56:
	.dbline 618
	mov R2,R24
	sts _KeySoundLen,R2
L130:
	.dbline 619
;       Key = 0xff;
	ldi R24,255
	sts _Key,R24
	.dbline 620
;     }
L128:
	.dbline 622
; 
;     if (Key == 11)
	lds R24,_Key
	cpi R24,11
	breq X61
	xjmp L132
X61:
X57:
	.dbline 623
;     {
	.dbline 624
;       Key = 0xff;
	ldi R24,255
	sts _Key,R24
	.dbline 625
;       if ((Value >= 0) && (Value < 11))
	lds R2,L122
	mov R24,R2
	cpi R24,0
	brlo L134
X58:
	cpi R24,11
	brsh L134
X59:
	.dbline 626
;       {
	.dbline 627
;         EEPROM_WRITE(EEPROM_KEYSOUNDLEN, Value);
	ldi R24,1
	ldi R25,0
	std y+1,R25
	std y+0,R24
	ldi R18,<L122
	ldi R19,>L122
	ldi R16,6
	ldi R17,0
	xcall _EEPROMWriteBytes
	.dbline 628
;         LCDGotoXY(1,1);
	ldi R18,1
	ldi R16,1
	xcall _LCDGotoXY
	.dbline 629
;         LCDWriteConstString("  New Value Saved   \0");
	ldi R16,<L136
	ldi R17,>L136
	xcall _LCDWriteConstString
	.dbline 630
;         Delay(75);
	ldi R16,75
	xcall _Delay
	.dbline 631
;         LCDGotoXY(1,1);
	ldi R18,1
	ldi R16,1
	xcall _LCDGotoXY
	.dbline 632
;         LCDWriteConstString("  ---------------   \0");
	ldi R16,<L137
	ldi R17,>L137
	xcall _LCDWriteConstString
	.dbline 633
;         DoKey(TRUE);
	ldi R16,1
	xcall _DoKey
	.dbline 634
;         return;
	xjmp L119
L134:
	.dbline 637
;       }
;       else
;       {
	.dbline 638
;         LCDGotoXY(1,1);
	ldi R18,1
	ldi R16,1
	xcall _LCDGotoXY
	.dbline 639
;         LCDWriteConstString(" Value Out Of Range \0");
	ldi R16,<L138
	ldi R17,>L138
	xcall _LCDWriteConstString
	.dbline 640
;         Delay(75);
	ldi R16,75
	xcall _Delay
	.dbline 641
;         LCDGotoXY(1,1);
	ldi R18,1
	ldi R16,1
	xcall _LCDGotoXY
	.dbline 642
;         LCDWriteConstString(" ------------------ \0");
	ldi R16,<L139
	ldi R17,>L139
	xcall _LCDWriteConstString
	.dbline 643
;         DoKey(TRUE);
	ldi R16,1
	xcall _DoKey
	.dbline 644
;         return;
	xjmp L119
L132:
	.dbline 647
;       }
;     }
;   }  
L126:
	.dbline 606
	xjmp L125
X60:
	.dbline -2
L119:
	.dbline 0 ; func end
	adiw R28,2
	ret
	.dbend
	.area bss(ram, con, rel)
	.dbfile C:\DATA\InterComm\CODENE~1\InterComm.c
L141:
	.blkb 1
L142:
	.blkb 1
L143:
	.blkb 1
	.area text(rom, con, rel)
	.dbfile C:\DATA\InterComm\CODENE~1\InterComm.c
	.dbfunc e SetKeySoundTone _SetKeySoundTone fV
	.dbsym s Value L143 c
	.dbsym s KeySecond L142 c
	.dbsym s KeyFirst L141 c
	.even
_SetKeySoundTone::
	sbiw R28,2
	.dbline -1
	.dbline 664
; }
; 
; /******************************************************************************
; 
; Name:			    SetKeySoundTone(void)
; 
; Description:	
; 
; Input:			  none
; 
; Output:			  none
; 
; Misc:			
; 
; ******************************************************************************/
; void SetKeySoundTone(void)
; {
	.dbline 667
;   static ushort KeyFirst,KeySecond,Value;
; 
;   LCDClrSCR();
	xcall _LCDClrSCR
	.dbline 668
;   LCDGotoXY(1,1);
	ldi R18,1
	ldi R16,1
	xcall _LCDGotoXY
	.dbline 669
;   csprintf(&Text[0],"Current Tone : %d\0",KeySoundTone);
	lds R2,_KeySoundTone
	clr R3
	std y+1,R3
	std y+0,R2
	ldi R18,<L123
	ldi R19,>L123
	ldi R16,<_Text
	ldi R17,>_Text
	xcall _csprintf
	.dbline 670
;   LCDWriteString(&Text[0]);
	ldi R16,<_Text
	ldi R17,>_Text
	xcall _LCDWriteString
	.dbline 671
;   LCDGotoXY(1,2);
	ldi R18,2
	ldi R16,1
	xcall _LCDGotoXY
	.dbline 672
;   LCDWriteConstString("New Tone(00-59):00\0");
	ldi R16,<L144
	ldi R17,>L144
	xcall _LCDWriteConstString
	xjmp L146
L145:
	.dbline 675
; 
;   while(TRUE)
;   {
	.dbline 676
;     WDR();
	wdr
	.dbline 677
;     KeyScan();
	xcall _KeyScan
	.dbline 678
;     if ((Key != 0xff) && (Key != 10) && (Key != 11))
	lds R2,_Key
	mov R24,R2
	cpi R24,255
	breq L148
X62:
	cpi R24,10
	breq L148
X63:
	cpi R24,11
	breq L148
X64:
	.dbline 679
;     {
	.dbline 680
;       KeySecond = KeyFirst;
	lds R2,L141
	sts L142,R2
	.dbline 681
;       KeyFirst = Key;
	mov R2,R24
	sts L141,R2
	.dbline 682
;       LCDGotoXY(17,2);
	ldi R18,2
	ldi R16,17
	xcall _LCDGotoXY
	.dbline 683
;       LCDWriteData(LCD_DATA,KeySecond+48);
	lds R18,L142
	subi R18,208    ; addi 48
	ldi R16,1
	xcall _LCDWriteData
	.dbline 684
;       LCDWriteData(LCD_DATA,KeyFirst+48);
	lds R18,L141
	subi R18,208    ; addi 48
	ldi R16,1
	xcall _LCDWriteData
	.dbline 685
;       Value = (KeySecond * 10) + KeyFirst;
	lds R2,L142
	ldi R24,10
	mul R24,R2
	lds R2,L141
	mov R3,R0
	add R3,R2
	sts L143,R3
	.dbline 686
;       if (Value < 59) KeySoundTone = Value;
	mov R24,R3
	cpi R24,59
	brsh L150
X65:
	.dbline 686
	mov R2,R24
	sts _KeySoundTone,R2
L150:
	.dbline 687
;       Key = 0xff;
	ldi R24,255
	sts _Key,R24
	.dbline 688
;     }
L148:
	.dbline 690
; 
;     if (Key == 11)
	lds R24,_Key
	cpi R24,11
	breq X70
	xjmp L152
X70:
X66:
	.dbline 691
;     {
	.dbline 692
;       Key = 0xff;
	ldi R24,255
	sts _Key,R24
	.dbline 693
;       if ((Value >= 0) && (Value <59))
	lds R2,L143
	mov R24,R2
	cpi R24,0
	brlo L154
X67:
	cpi R24,59
	brsh L154
X68:
	.dbline 694
;       {
	.dbline 695
;         EEPROM_WRITE(EEPROM_KEYSOUNDTONE, Value);
	ldi R24,1
	ldi R25,0
	std y+1,R25
	std y+0,R24
	ldi R18,<L143
	ldi R19,>L143
	ldi R16,5
	ldi R17,0
	xcall _EEPROMWriteBytes
	.dbline 696
;         LCDGotoXY(1,1);
	ldi R18,1
	ldi R16,1
	xcall _LCDGotoXY
	.dbline 697
;         LCDWriteConstString("  New Value Saved   \0");
	ldi R16,<L136
	ldi R17,>L136
	xcall _LCDWriteConstString
	.dbline 698
;         Delay(75);
	ldi R16,75
	xcall _Delay
	.dbline 699
;         LCDGotoXY(1,1);
	ldi R18,1
	ldi R16,1
	xcall _LCDGotoXY
	.dbline 700
;         LCDWriteConstString("  ---------------   \0");
	ldi R16,<L137
	ldi R17,>L137
	xcall _LCDWriteConstString
	.dbline 701
;         DoKey(TRUE);
	ldi R16,1
	xcall _DoKey
	.dbline 702
;         return;
	xjmp L140
L154:
	.dbline 705
;       }
;       else
;       {
	.dbline 706
;         LCDGotoXY(1,1);
	ldi R18,1
	ldi R16,1
	xcall _LCDGotoXY
	.dbline 707
;         LCDWriteConstString(" Value Out Of Range \0");
	ldi R16,<L138
	ldi R17,>L138
	xcall _LCDWriteConstString
	.dbline 708
;         Delay(75);
	ldi R16,75
	xcall _Delay
	.dbline 709
;         LCDGotoXY(1,1);
	ldi R18,1
	ldi R16,1
	xcall _LCDGotoXY
	.dbline 710
;         LCDWriteConstString(" ------------------ \0");
	ldi R16,<L139
	ldi R17,>L139
	xcall _LCDWriteConstString
	.dbline 711
;         DoKey(TRUE);
	ldi R16,1
	xcall _DoKey
	.dbline 712
;         return;
	xjmp L140
L152:
	.dbline 715
;       }
;     }
;   }  
L146:
	.dbline 674
	xjmp L145
X69:
	.dbline -2
L140:
	.dbline 0 ; func end
	adiw R28,2
	ret
	.dbend
	.area bss(ram, con, rel)
	.dbfile C:\DATA\InterComm\CODENE~1\InterComm.c
L157:
	.blkb 1
L158:
	.blkb 1
L159:
	.blkb 1
	.area text(rom, con, rel)
	.dbfile C:\DATA\InterComm\CODENE~1\InterComm.c
	.dbfunc e SetKeySoundVolume _SetKeySoundVolume fV
	.dbsym s Value L159 c
	.dbsym s KeySecond L158 c
	.dbsym s KeyFirst L157 c
	.even
_SetKeySoundVolume::
	sbiw R28,2
	.dbline -1
	.dbline 732
; }
; 
; /******************************************************************************
; 
; Name:			    SetKeySoundVolume(void)
; 
; Description:	
; 
; Input:			  none
; 
; Output:			  none
; 
; Misc:			
; 
; ******************************************************************************/
; void SetKeySoundVolume(void)
; {
	.dbline 735
;   static ushort KeyFirst,KeySecond,Value;
; 
;   LCDClrSCR();
	xcall _LCDClrSCR
	.dbline 736
;   LCDGotoXY(1,1);
	ldi R18,1
	ldi R16,1
	xcall _LCDGotoXY
	.dbline 737
;   csprintf(&Text[0],"Current Key Vol:%d\0",KeySoundVolume);
	lds R2,_KeySoundVolume
	clr R3
	std y+1,R3
	std y+0,R2
	ldi R18,<L160
	ldi R19,>L160
	ldi R16,<_Text
	ldi R17,>_Text
	xcall _csprintf
	.dbline 738
;   LCDWriteString(&Text[0]);
	ldi R16,<_Text
	ldi R17,>_Text
	xcall _LCDWriteString
	.dbline 739
;   LCDGotoXY(1,2);
	ldi R18,2
	ldi R16,1
	xcall _LCDGotoXY
	.dbline 740
;   LCDWriteConstString("New Key Vol 00-99:00\0");
	ldi R16,<L161
	ldi R17,>L161
	xcall _LCDWriteConstString
	xjmp L163
L162:
	.dbline 743
; 
;   while(TRUE)
;   {
	.dbline 744
;     WDR();
	wdr
	.dbline 745
;     KeyScan();
	xcall _KeyScan
	.dbline 746
;     if ((Key != 0xff) && (Key != 10) && (Key != 11))
	lds R2,_Key
	mov R24,R2
	cpi R24,255
	breq L165
X71:
	cpi R24,10
	breq L165
X72:
	cpi R24,11
	breq L165
X73:
	.dbline 747
;     {
	.dbline 748
;       KeySecond = KeyFirst;
	lds R2,L157
	sts L158,R2
	.dbline 749
;       KeyFirst = Key;
	mov R2,R24
	sts L157,R2
	.dbline 750
;       LCDGotoXY(19,2);
	ldi R18,2
	ldi R16,19
	xcall _LCDGotoXY
	.dbline 751
;       LCDWriteData(LCD_DATA,KeySecond+48);
	lds R18,L158
	subi R18,208    ; addi 48
	ldi R16,1
	xcall _LCDWriteData
	.dbline 752
;       LCDWriteData(LCD_DATA,KeyFirst+48);
	lds R18,L157
	subi R18,208    ; addi 48
	ldi R16,1
	xcall _LCDWriteData
	.dbline 753
;       Value = (KeySecond * 10) + KeyFirst;
	lds R2,L158
	ldi R24,10
	mul R24,R2
	lds R2,L157
	mov R3,R0
	add R3,R2
	sts L159,R3
	.dbline 754
;       KeySoundVolume = Value;
	mov R2,R3
	sts _KeySoundVolume,R2
	.dbline 755
;       Key = 0xff;
	ldi R24,255
	sts _Key,R24
	.dbline 756
;     }
L165:
	.dbline 758
; 
;     if (Key == 11)
	lds R24,_Key
	cpi R24,11
	brne L167
X74:
	.dbline 759
;     {
	.dbline 760
;       Key = 0xff;
	ldi R24,255
	sts _Key,R24
	.dbline 761
;       EEPROM_WRITE(EEPROM_KEYSOUNDVOLUME, Value);
	ldi R24,1
	ldi R25,0
	std y+1,R25
	std y+0,R24
	ldi R18,<L159
	ldi R19,>L159
	ldi R16,4
	ldi R17,0
	xcall _EEPROMWriteBytes
	.dbline 762
;       LCDGotoXY(1,1);
	ldi R18,1
	ldi R16,1
	xcall _LCDGotoXY
	.dbline 763
;       LCDWriteConstString("  New Value Saved   \0");
	ldi R16,<L136
	ldi R17,>L136
	xcall _LCDWriteConstString
	.dbline 764
;       Delay(75);
	ldi R16,75
	xcall _Delay
	.dbline 765
;       LCDGotoXY(1,1);
	ldi R18,1
	ldi R16,1
	xcall _LCDGotoXY
	.dbline 766
;       LCDWriteConstString("  ---------------   \0");
	ldi R16,<L137
	ldi R17,>L137
	xcall _LCDWriteConstString
	.dbline 767
;       DoKey(TRUE);
	ldi R16,1
	xcall _DoKey
	.dbline 768
;       return;
	xjmp L156
L167:
	.dbline 770
;     }
;   }
L163:
	.dbline 742
	xjmp L162
X75:
	.dbline -2
L156:
	.dbline 0 ; func end
	adiw R28,2
	ret
	.dbend
	.dbfunc e SetKeySound _SetKeySound fV
	.even
_SetKeySound::
	sbiw R28,2
	.dbline -1
	.dbline 787
; }
; 
; /******************************************************************************
; 
; Name:			    SetKeySound(void)
; 
; Description:	
; 
; Input:			  none
; 
; Output:			  none
; 
; Misc:			
; 
; ******************************************************************************/
; void SetKeySound(void)
; {
	.dbline 788
;   LCDClrSCR();
	xcall _LCDClrSCR
	.dbline 789
;   LCDGotoXY(1,1);
	ldi R18,1
	ldi R16,1
	xcall _LCDGotoXY
	.dbline 790
;   if (KeySound) LCDWriteConstString("Key Sound is ON     \0");
	lds R2,_KeySound
	tst R2
	breq L170
X76:
	.dbline 790
	ldi R16,<L172
	ldi R17,>L172
	xcall _LCDWriteConstString
	xjmp L171
L170:
	.dbline 791
;   else LCDWriteConstString("Key Sound is OFF    \0");
	ldi R16,<L173
	ldi R17,>L173
	xcall _LCDWriteConstString
L171:
	.dbline 792
;   LCDGotoXY(1,2);
	ldi R18,2
	ldi R16,1
	xcall _LCDGotoXY
	.dbline 793
;   LCDWriteConstString("* To Toggle  #->Save\0");
	ldi R16,<L174
	ldi R17,>L174
	xcall _LCDWriteConstString
	xjmp L176
L175:
	.dbline 796
; 
;   while(TRUE)
;   {
	.dbline 797
;     WDR();
	wdr
	.dbline 798
;     KeyScan();
	xcall _KeyScan
	.dbline 799
;     if ((Key != 0xff) && (Key == 10))
	lds R2,_Key
	mov R24,R2
	cpi R24,255
	breq L178
X77:
	cpi R24,10
	brne L178
X78:
	.dbline 800
;     {
	.dbline 801
;       if (KeySound) KeySound = 0;
	lds R2,_KeySound
	tst R2
	breq L180
X79:
	.dbline 801
	clr R2
	sts _KeySound,R2
	xjmp L181
L180:
	.dbline 802
;       else KeySound = 1;
	ldi R24,1
	sts _KeySound,R24
L181:
	.dbline 803
;       Key = 0xff;
	ldi R24,255
	sts _Key,R24
	.dbline 804
;       LCDGotoXY(1,1);
	ldi R18,1
	ldi R16,1
	xcall _LCDGotoXY
	.dbline 805
;       if (KeySound) LCDWriteConstString("Key Sound is ON     \0");
	lds R2,_KeySound
	tst R2
	breq L182
X80:
	.dbline 805
	ldi R16,<L172
	ldi R17,>L172
	xcall _LCDWriteConstString
	xjmp L183
L182:
	.dbline 806
;       else LCDWriteConstString("Key Sound is OFF    \0");
	ldi R16,<L173
	ldi R17,>L173
	xcall _LCDWriteConstString
L183:
	.dbline 807
;     }
L178:
	.dbline 809
; 
;     if (Key == 11)
	lds R24,_Key
	cpi R24,11
	brne L184
X81:
	.dbline 810
;     {
	.dbline 811
;       Key = 0xff;
	ldi R24,255
	sts _Key,R24
	.dbline 812
;       EEPROM_WRITE(EEPROM_KEYSOUND, KeySound);
	ldi R24,1
	ldi R25,0
	std y+1,R25
	std y+0,R24
	ldi R18,<_KeySound
	ldi R19,>_KeySound
	ldi R16,3
	ldi R17,0
	xcall _EEPROMWriteBytes
	.dbline 813
;       LCDGotoXY(1,1);
	ldi R18,1
	ldi R16,1
	xcall _LCDGotoXY
	.dbline 814
;       LCDWriteConstString("  New Value Saved   \0");
	ldi R16,<L136
	ldi R17,>L136
	xcall _LCDWriteConstString
	.dbline 815
;       Delay(75);
	ldi R16,75
	xcall _Delay
	.dbline 816
;       LCDGotoXY(1,1);
	ldi R18,1
	ldi R16,1
	xcall _LCDGotoXY
	.dbline 817
;       LCDWriteConstString("  ---------------   \0");
	ldi R16,<L137
	ldi R17,>L137
	xcall _LCDWriteConstString
	.dbline 818
;       DoKey(TRUE);
	ldi R16,1
	xcall _DoKey
	.dbline 819
;       return;
	xjmp L169
L184:
	.dbline 821
;     }
;   }
L176:
	.dbline 795
	xjmp L175
X82:
	.dbline -2
L169:
	.dbline 0 ; func end
	adiw R28,2
	ret
	.dbend
	.dbfunc e SetBroadCastEnable _SetBroadCastEnable fV
	.even
_SetBroadCastEnable::
	sbiw R28,2
	.dbline -1
	.dbline 838
; }
; 
; /******************************************************************************
; 
; Name:			    SetBroadCastEnable(void)
; 
; Description:	
; 
; Input:			  none
; 
; Output:			  none
; 
; Misc:			
; 
; ******************************************************************************/
; void SetBroadCastEnable(void)
; {
	.dbline 839
;   LCDClrSCR();
	xcall _LCDClrSCR
	.dbline 840
;   LCDGotoXY(1,1);
	ldi R18,1
	ldi R16,1
	xcall _LCDGotoXY
	.dbline 841
;   if (BroadCastEnable) LCDWriteConstString("BroadCast is ON     \0");
	lds R2,_BroadCastEnable
	tst R2
	breq L187
X83:
	.dbline 841
	ldi R16,<L189
	ldi R17,>L189
	xcall _LCDWriteConstString
	xjmp L188
L187:
	.dbline 842
;   else LCDWriteConstString("BroadCast is OFF    \0");
	ldi R16,<L190
	ldi R17,>L190
	xcall _LCDWriteConstString
L188:
	.dbline 843
;   LCDGotoXY(1,2);
	ldi R18,2
	ldi R16,1
	xcall _LCDGotoXY
	.dbline 844
;   LCDWriteConstString("* To Toggle  #->Save\0");
	ldi R16,<L174
	ldi R17,>L174
	xcall _LCDWriteConstString
	xjmp L192
L191:
	.dbline 847
; 
;   while(TRUE)
;   {
	.dbline 848
;     WDR();
	wdr
	.dbline 849
;     KeyScan();
	xcall _KeyScan
	.dbline 850
;     if ((Key != 0xff) && (Key == 10))
	lds R2,_Key
	mov R24,R2
	cpi R24,255
	breq L194
X84:
	cpi R24,10
	brne L194
X85:
	.dbline 851
;     {
	.dbline 852
;       if (BroadCastEnable) BroadCastEnable = 0;
	lds R2,_BroadCastEnable
	tst R2
	breq L196
X86:
	.dbline 852
	clr R2
	sts _BroadCastEnable,R2
	xjmp L197
L196:
	.dbline 853
;       else BroadCastEnable = 1;
	ldi R24,1
	sts _BroadCastEnable,R24
L197:
	.dbline 854
;       Key = 0xff;
	ldi R24,255
	sts _Key,R24
	.dbline 855
;       LCDGotoXY(1,1);
	ldi R18,1
	ldi R16,1
	xcall _LCDGotoXY
	.dbline 856
;       if (BroadCastEnable) LCDWriteConstString("BroadCast is ON     \0");
	lds R2,_BroadCastEnable
	tst R2
	breq L198
X87:
	.dbline 856
	ldi R16,<L189
	ldi R17,>L189
	xcall _LCDWriteConstString
	xjmp L199
L198:
	.dbline 857
;       else LCDWriteConstString("BroadCast is OFF    \0");
	ldi R16,<L190
	ldi R17,>L190
	xcall _LCDWriteConstString
L199:
	.dbline 858
;     }
L194:
	.dbline 860
; 
;     if (Key == 11)
	lds R24,_Key
	cpi R24,11
	brne L200
X88:
	.dbline 861
;     {
	.dbline 862
;       Key = 0xff;
	ldi R24,255
	sts _Key,R24
	.dbline 863
;       EEPROM_WRITE(EEPROM_BROADCAST, BroadCastEnable);
	ldi R24,1
	ldi R25,0
	std y+1,R25
	std y+0,R24
	ldi R18,<_BroadCastEnable
	ldi R19,>_BroadCastEnable
	ldi R16,7
	ldi R17,0
	xcall _EEPROMWriteBytes
	.dbline 864
;       LCDGotoXY(1,1);
	ldi R18,1
	ldi R16,1
	xcall _LCDGotoXY
	.dbline 865
;       LCDWriteConstString("  New Value Saved   \0");
	ldi R16,<L136
	ldi R17,>L136
	xcall _LCDWriteConstString
	.dbline 866
;       Delay(75);
	ldi R16,75
	xcall _Delay
	.dbline 867
;       LCDGotoXY(1,1);
	ldi R18,1
	ldi R16,1
	xcall _LCDGotoXY
	.dbline 868
;       LCDWriteConstString("  ---------------   \0");
	ldi R16,<L137
	ldi R17,>L137
	xcall _LCDWriteConstString
	.dbline 869
;       DoKey(TRUE);
	ldi R16,1
	xcall _DoKey
	.dbline 870
;       return;
	xjmp L186
L200:
	.dbline 872
;     }
;   }
L192:
	.dbline 846
	xjmp L191
X89:
	.dbline -2
L186:
	.dbline 0 ; func end
	adiw R28,2
	ret
	.dbend
	.area bss(ram, con, rel)
	.dbfile C:\DATA\InterComm\CODENE~1\InterComm.c
L203:
	.blkb 1
L204:
	.blkb 1
L205:
	.blkb 1
	.area text(rom, con, rel)
	.dbfile C:\DATA\InterComm\CODENE~1\InterComm.c
	.dbfunc e SetStationAddress _SetStationAddress fV
	.dbsym s Value L205 c
	.dbsym s KeySecond L204 c
	.dbsym s KeyFirst L203 c
	.even
_SetStationAddress::
	sbiw R28,2
	.dbline -1
	.dbline 889
; }
; 
; /******************************************************************************
; 
; Name:			    SetStationAddress(void)
; 
; Description:	
; 
; Input:			  none
; 
; Output:			  none
; 
; Misc:			
; 
; ******************************************************************************/
; void SetStationAddress(void)
; {
	.dbline 892
;   static ushort KeyFirst,KeySecond,Value;
; 
;   LCDClrSCR();
	xcall _LCDClrSCR
	.dbline 893
;   LCDGotoXY(1,1);
	ldi R18,1
	ldi R16,1
	xcall _LCDGotoXY
	.dbline 894
;   csprintf(&Text[0],"Current Address : %d\0",NetAddress);
	lds R2,_NetAddress
	clr R3
	std y+1,R3
	std y+0,R2
	ldi R18,<L206
	ldi R19,>L206
	ldi R16,<_Text
	ldi R17,>_Text
	xcall _csprintf
	.dbline 895
;   LCDWriteString(&Text[0]);
	ldi R16,<_Text
	ldi R17,>_Text
	xcall _LCDWriteString
	.dbline 896
;   LCDGotoXY(1,2);
	ldi R18,2
	ldi R16,1
	xcall _LCDGotoXY
	.dbline 897
;   LCDWriteConstString("New Adr(00-39) : 00\0");
	ldi R16,<L207
	ldi R17,>L207
	xcall _LCDWriteConstString
	xjmp L209
L208:
	.dbline 900
; 
;   while(TRUE)
;   {
	.dbline 901
;     WDR();
	wdr
	.dbline 902
;     KeyScan();
	xcall _KeyScan
	.dbline 903
;     if ((Key != 0xff) && (Key != 10) && (Key != 11))
	lds R2,_Key
	mov R24,R2
	cpi R24,255
	breq L211
X90:
	cpi R24,10
	breq L211
X91:
	cpi R24,11
	breq L211
X92:
	.dbline 904
;     {
	.dbline 905
;       KeySecond = KeyFirst;
	lds R2,L203
	sts L204,R2
	.dbline 906
;       KeyFirst = Key;
	mov R2,R24
	sts L203,R2
	.dbline 907
;       LCDGotoXY(18,2);
	ldi R18,2
	ldi R16,18
	xcall _LCDGotoXY
	.dbline 908
;       LCDWriteData(LCD_DATA,KeySecond+48);
	lds R18,L204
	subi R18,208    ; addi 48
	ldi R16,1
	xcall _LCDWriteData
	.dbline 909
;       LCDWriteData(LCD_DATA,KeyFirst+48);
	lds R18,L203
	subi R18,208    ; addi 48
	ldi R16,1
	xcall _LCDWriteData
	.dbline 910
;       Value = (KeySecond * 10) + KeyFirst;
	lds R2,L204
	ldi R24,10
	mul R24,R2
	lds R2,L203
	mov R3,R0
	add R3,R2
	sts L205,R3
	.dbline 911
;       Key = 0xff;
	ldi R24,255
	sts _Key,R24
	.dbline 912
;     }
L211:
	.dbline 914
; 
;     if (Key == 11)
	lds R24,_Key
	cpi R24,11
	breq X97
	xjmp L213
X97:
X93:
	.dbline 915
;     {
	.dbline 916
;       Key = 0xff;
	ldi R24,255
	sts _Key,R24
	.dbline 917
;       if ((Value >= 0) && (Value <40))
	lds R2,L205
	mov R24,R2
	cpi R24,0
	brlo L215
X94:
	cpi R24,40
	brsh L215
X95:
	.dbline 918
;       {
	.dbline 919
;         EEPROM_WRITE(EEPROM_ADDRESS, Value);
	ldi R24,1
	ldi R25,0
	std y+1,R25
	std y+0,R24
	ldi R18,<L205
	ldi R19,>L205
	ldi R16,2
	ldi R17,0
	xcall _EEPROMWriteBytes
	.dbline 920
;         NetGetAddress();
	xcall _NetGetAddress
	.dbline 921
;         LCDGotoXY(1,1);
	ldi R18,1
	ldi R16,1
	xcall _LCDGotoXY
	.dbline 922
;         LCDWriteConstString("  New Value Saved   \0");
	ldi R16,<L136
	ldi R17,>L136
	xcall _LCDWriteConstString
	.dbline 923
;         Delay(75);
	ldi R16,75
	xcall _Delay
	.dbline 924
;         LCDGotoXY(1,1);
	ldi R18,1
	ldi R16,1
	xcall _LCDGotoXY
	.dbline 925
;         LCDWriteConstString("  ---------------   \0");
	ldi R16,<L137
	ldi R17,>L137
	xcall _LCDWriteConstString
	.dbline 926
;         DoKey(TRUE);
	ldi R16,1
	xcall _DoKey
	.dbline 927
;         return;
	xjmp L202
L215:
	.dbline 930
;       }
;       else
;       {
	.dbline 931
;         LCDGotoXY(1,1);
	ldi R18,1
	ldi R16,1
	xcall _LCDGotoXY
	.dbline 932
;         LCDWriteConstString(" Value Out Of Range \0");
	ldi R16,<L138
	ldi R17,>L138
	xcall _LCDWriteConstString
	.dbline 933
;         Delay(75);
	ldi R16,75
	xcall _Delay
	.dbline 934
;         LCDGotoXY(1,1);
	ldi R18,1
	ldi R16,1
	xcall _LCDGotoXY
	.dbline 935
;         LCDWriteConstString(" ------------------ \0");
	ldi R16,<L139
	ldi R17,>L139
	xcall _LCDWriteConstString
	.dbline 936
;         DoKey(TRUE);
	ldi R16,1
	xcall _DoKey
	.dbline 937
;         return;
	xjmp L202
L213:
	.dbline 940
;       }
;     }
;   }
L209:
	.dbline 899
	xjmp L208
X96:
	.dbline -2
L202:
	.dbline 0 ; func end
	adiw R28,2
	ret
	.dbend
	.dbfunc e StationCall _StationCall fV
;        Station -> R10
	.even
_StationCall::
	xcall push_xgset300C
	mov R10,R16
	sbiw R28,2
	.dbline -1
	.dbline 957
; }
; 
; /******************************************************************************
; 
; Name:			    void StationCall(ushort Station)
; 
; Description:	
; 
; Input:			  none
; 
; Output:			  none
; 
; Misc:			
; 
; ******************************************************************************/
; void StationCall(ushort Station)
; {  
	.dbline 958
;   VoiceVolume(Volume); 
	lds R16,_Volume
	xcall _VoiceVolume
	.dbline 959
;   LCDClrSCR();
	xcall _LCDClrSCR
	.dbline 960
;   LCDGotoXY(1,1);
	ldi R18,1
	ldi R16,1
	xcall _LCDGotoXY
	.dbline 961
;   csprintf(&Text[0],"Calling Station :#%d\0",Station); 
	mov R2,R10
	clr R3
	std y+1,R3
	std y+0,R2
	ldi R18,<L218
	ldi R19,>L218
	ldi R16,<_Text
	ldi R17,>_Text
	xcall _csprintf
	.dbline 962
;   LCDWriteString(&Text[0]);
	ldi R16,<_Text
	ldi R17,>_Text
	xcall _LCDWriteString
	.dbline 963
;   LCDGotoXY(1,2);
	ldi R18,2
	ldi R16,1
	xcall _LCDGotoXY
	.dbline 964
;   LCDWriteConstString("#->Talk *->End      \0"); 
	ldi R16,<L219
	ldi R17,>L219
	xcall _LCDWriteConstString
	.dbline 965
;   Delay(10);
	ldi R16,10
	xcall _Delay
	.dbline 967
; 
;   NetSendCommand(0xff,BUSY);
	ldi R18,4
	ldi R16,255
	xcall _NetSendCommand
	.dbline 968
;   NetSendCommand(Station,TALK);
	ldi R18,1
	mov R16,R10
	xcall _NetSendCommand
	.dbline 969
;   InterCommMode = LISTEN;
	ldi R24,2
	sts _InterCommMode,R24
	.dbline 970
;   NET_UCSRA &= ~(1<<MPCM);
	cbi 0xb,0
	xjmp L221
L220:
	.dbline 973
;   
;   while(KeyLook() != 10)
;   {
	.dbline 974
;     WDR();
	wdr
	.dbline 975
;     if ((InterCommMode == LISTEN) && (KeyLook() == 11))
	lds R24,_InterCommMode
	cpi R24,2
	brne L223
X98:
	xcall _KeyLook
	cpi R16,11
	brne L223
X99:
	.dbline 976
;       {
	.dbline 977
;         NetSendCommand(Station,LISTEN);
	ldi R18,2
	mov R16,R10
	xcall _NetSendCommand
	.dbline 978
;         Delay(2);
	ldi R16,2
	xcall _Delay
	.dbline 979
;         InterCommMode = TALK;
	ldi R24,1
	sts _InterCommMode,R24
	.dbline 980
;       }
L223:
	.dbline 981
;     if ((InterCommMode == TALK) && (KeyLook() == 0xff))
	lds R24,_InterCommMode
	cpi R24,1
	brne L225
X100:
	xcall _KeyLook
	cpi R16,255
	brne L225
X101:
	.dbline 982
;       {
	.dbline 983
;         NetSendCommand(Station,TALK);
	ldi R18,1
	mov R16,R10
	xcall _NetSendCommand
	.dbline 984
;         Delay(2);
	ldi R16,2
	xcall _Delay
	.dbline 985
;         InterCommMode = LISTEN;
	ldi R24,2
	sts _InterCommMode,R24
	.dbline 986
;         NET_UCSRA &= ~(1<<MPCM);
	cbi 0xb,0
	.dbline 987
;       }
L225:
	.dbline 988
;   }
L221:
	.dbline 972
	xcall _KeyLook
	mov R20,R16
	cpi R16,10
	brne L220
X102:
	.dbline 990
; 
; 	SendRelease();
	xcall _SendRelease
	.dbline 991
; 	DoKey(TRUE);
	ldi R16,1
	xcall _DoKey
	.dbline -2
L217:
	.dbline 0 ; func end
	adiw R28,2
	xjmp pop_xgset300C
	.dbsym r Station 10 c
	.dbend
	.dbfunc e BroadCastCall _BroadCastCall fV
	.even
_BroadCastCall::
	.dbline -1
	.dbline 1008
; }        
; 
; /******************************************************************************
; 
; Name:			    void BroadCastCall(void)
; 
; Description:	
; 
; Input:			  none
; 
; Output:			  none
; 
; Misc:			
; 
; ******************************************************************************/
; void BroadCastCall(void)
; {  
	.dbline 1009
;   VoiceVolume(Volume); 
	lds R16,_Volume
	xcall _VoiceVolume
	.dbline 1010
;   LCDClrSCR();
	xcall _LCDClrSCR
	.dbline 1011
;   LCDGotoXY(1,1);
	ldi R18,1
	ldi R16,1
	xcall _LCDGotoXY
	.dbline 1012
;   LCDWriteConstString("   BroadCast Call   \0"); 
	ldi R16,<L228
	ldi R17,>L228
	xcall _LCDWriteConstString
	.dbline 1013
;   LCDGotoXY(1,2);
	ldi R18,2
	ldi R16,1
	xcall _LCDGotoXY
	.dbline 1014
;   LCDWriteConstString("   #->Talk *->End   \0"); 
	ldi R16,<L229
	ldi R17,>L229
	xcall _LCDWriteConstString
	.dbline 1015
;   Delay(10);
	ldi R16,10
	xcall _Delay
	.dbline 1017
; 
;   NetSendCommand(0xff,BUSY);
	ldi R18,4
	ldi R16,255
	xcall _NetSendCommand
	.dbline 1018
;   InterCommMode = OFF;
	clr R2
	sts _InterCommMode,R2
	xjmp L231
L230:
	.dbline 1021
;   
;   while(KeyLook() != 10)
;   {
	.dbline 1022
;     WDR();
	wdr
	.dbline 1023
;     if ((InterCommMode == OFF) && (KeyLook() == 11))
	lds R2,_InterCommMode
	tst R2
	brne L233
X103:
	xcall _KeyLook
	cpi R16,11
	brne L233
X104:
	.dbline 1024
;       {
	.dbline 1025
;         NetSendCommand(0xfe,LISTEN);
	ldi R18,2
	ldi R16,254
	xcall _NetSendCommand
	.dbline 1026
;         InterCommMode = TALK;
	ldi R24,1
	sts _InterCommMode,R24
	.dbline 1027
;       }
L233:
	.dbline 1028
;   }
L231:
	.dbline 1020
	xcall _KeyLook
	cpi R16,10
	brne L230
X105:
	.dbline 1029
;   SendRelease();
	xcall _SendRelease
	.dbline 1030
; 	DoKey(TRUE);
	ldi R16,1
	xcall _DoKey
	.dbline -2
L227:
	.dbline 0 ; func end
	ret
	.dbend
	.dbfunc e SendRelease _SendRelease fV
	.even
_SendRelease::
	.dbline -1
	.dbline 1048
; }        
; 
; /******************************************************************************
; 
; Name:         void SendRelease(void)
; 
; Description:  This function release the communication
; 
; 
; 
; Input:        none
; 
; Output:       none
; 
; Misc:
; ******************************************************************************/
; void SendRelease(void)
; {
	.dbline 1049
;   InterCommMode = OFF;
	clr R2
	sts _InterCommMode,R2
	.dbline 1050
;   IncommingCall = FALSE;
	sts _IncommingCall,R2
	.dbline 1051
;   Delay(10);
	ldi R16,10
	xcall _Delay
	.dbline 1052
;   NetSendCommand(0xff,OFF);
	clr R18
	ldi R16,255
	xcall _NetSendCommand
	.dbline 1053
;   Delay(10);
	ldi R16,10
	xcall _Delay
	.dbline 1054
;   NetSendCommand(0xff,OFF);
	clr R18
	ldi R16,255
	xcall _NetSendCommand
	.dbline 1055
;   Delay(10);
	ldi R16,10
	xcall _Delay
	.dbline 1056
;   NetSendCommand(0xff,OFF);
	clr R18
	ldi R16,255
	xcall _NetSendCommand
	.dbline 1057
;   VoiceVolume(0); 
	clr R16
	xcall _VoiceVolume
	.dbline 1058
;   LCDGotoXY(1,1);
	ldi R18,1
	ldi R16,1
	xcall _LCDGotoXY
	.dbline 1059
;   LCDWriteConstString("Communication ended \0"); 
	ldi R16,<L111
	ldi R17,>L111
	xcall _LCDWriteConstString
	.dbline 1060
;   Delay(75);
	ldi R16,75
	xcall _Delay
	.dbline 1061
;   LCDGotoXY(1,1);
	ldi R18,1
	ldi R16,1
	xcall _LCDGotoXY
	.dbline 1062
;   LCDWriteConstString("                    \0"); 
	ldi R16,<L31
	ldi R17,>L31
	xcall _LCDWriteConstString
	.dbline 1063
;   DoKey(TRUE);
	ldi R16,1
	xcall _DoKey
	.dbline -2
L235:
	.dbline 0 ; func end
	ret
	.dbend
	.dbfunc e _StackOverflowed __StackOverflowed fV
;              c -> R16
	.even
__StackOverflowed::
	.dbline -1
	.dbline 1081
; }
; 
; /******************************************************************************
; 
; Name:         void _StackOverflowed(char c)
; 
; Description:  This function is automaticaly called if
;               the stack crash/
; 
; 
; Input:        none
; 
; Output:       none
; 
; Misc:
; ******************************************************************************/
; void _StackOverflowed(char c)
; {
	xjmp L238
L237:
	.dbline 1083
;   while(TRUE)
;   {
	.dbline 1084
;     DDRD |= LED;
	sbi 0x11,3
	.dbline 1085
;     PORTD |= LED;
	sbi 0x12,3
	.dbline 1086
;   }
L238:
	.dbline 1082
	xjmp L237
X106:
	.dbline -2
L236:
	.dbline 0 ; func end
	ret
	.dbsym r c 16 c
	.dbend
	.dbfunc e Led _Led fV
	.even
_Led::
	.dbline -1
	.dbline 1102
; }
; 
; /******************************************************************************
; 
; Name:         void Led(void)
; 
; Description:  This function invert the led
; 
; Input:        none
; 
; Output:       none
; 
; Misc:
; ******************************************************************************/
; void Led(void)
; {
	.dbline 1103
;   DDRD |= LED;
	sbi 0x11,3
	.dbline 1104
;   PORTD ^= LED;
	ldi R24,8
	in R2,0x12
	eor R2,R24
	out 0x12,R2
	.dbline -2
L240:
	.dbline 0 ; func end
	ret
	.dbend
	.dbfunc e Info _Info fV
	.even
_Info::
	.dbline -1
	.dbline 1121
; }
; 
; /*****************************************************************************
; 
; Name:         void Info(void)
; 
; Description:  Display power on message
; 
; Input:        void
; 
; Output:       void
; 
; Misc:         
; 
; ******************************************************************************/
; void Info(void)
; {
	.dbline 1122
;   LCDClrSCR();
	xcall _LCDClrSCR
	.dbline 1123
;   LCDGotoXY(1,1);
	ldi R18,1
	ldi R16,1
	xcall _LCDGotoXY
	.dbline 1124
;   LCDWriteConstString(VERSIONTEXT);
	ldi R16,<L42
	ldi R17,>L42
	xcall _LCDWriteConstString
	.dbline 1125
;   LCDGotoXY(1,2);
	ldi R18,2
	ldi R16,1
	xcall _LCDGotoXY
	.dbline 1126
;   LCDWriteConstString("--------------------\0");
	ldi R16,<L242
	ldi R17,>L242
	xcall _LCDWriteConstString
	.dbline -2
L241:
	.dbline 0 ; func end
	ret
	.dbend
	.dbfunc e Delay _Delay fV
;              i -> R20,R21
;              j -> R22,R23
;            Del -> R16
	.even
_Delay::
	xcall push_xgsetF000
	.dbline -1
	.dbline 1142
; }
; 
; /******************************************************************************
; 
; Name:         void Delay(ushort Del)
; 
; Description:  This function make a delay
; 
; Input:        none
; 
; Output:       none
; 
; Misc:
; ******************************************************************************/
; void Delay(ushort Del)
; {
	.dbline 1144
;   int i,j;
;   for (i=0;i<Del;i++) for (j=0;j<32000;j++) WDR();
	clr R20
	clr R21
	xjmp L247
L244:
	.dbline 1144
	clr R22
	clr R23
L248:
	.dbline 1144
	wdr
L249:
	.dbline 1144
	subi R22,255  ; offset = 1
	sbci R23,255
	.dbline 1144
	cpi R22,0
	ldi R30,125
	cpc R23,R30
	brlt L248
X107:
L245:
	.dbline 1144
	subi R20,255  ; offset = 1
	sbci R21,255
L247:
	.dbline 1144
	mov R2,R16
	clr R3
	cp R20,R2
	cpc R21,R3
	brlt L244
X108:
	.dbline -2
L243:
	.dbline 0 ; func end
	xjmp pop_xgsetF000
	.dbsym r i 20 I
	.dbsym r j 22 I
	.dbsym r Del 16 c
	.dbend
	.dbfunc e ADInit _ADInit fV
	.even
_ADInit::
	.dbline -1
	.dbline 1160
; }
; 
; /******************************************************************************
; 
; Name:         void ADInit(void)
; 
; Description:  This function initialize the AD converter
; 
; Input:        none
; 
; Output:       none
; 
; Misc:
; ******************************************************************************/
; void ADInit(void)
; {
	.dbline 1161
;   DDRA &= ~(1<<PA1);
	cbi 0x1a,1
	.dbline 1162
;   PORTA &= ~(1<<PA1);
	cbi 0x1b,1
	.dbline 1163
;   ADMUX = (1<<REFS0) + (1<<ADLAR) + (1<<MUX0);
	ldi R24,97
	out 0x7,R24
	.dbline 1164
;   ADCSRA = (1<<ADEN) + (1<<ADIE) + (1<<ADPS2) + (1<<ADPS0);  // 500ks/sec
	ldi R24,141
	out 0x6,R24
	.dbline -2
L252:
	.dbline 0 ; func end
	ret
	.dbend
	.dbfunc e ADStart _ADStart fV
	.even
_ADStart::
	.dbline -1
	.dbline 1180
; }
; 
; /******************************************************************************
; 
; Name:         void ADStart(void)
; 
; Description:  This function start a AD convertion
; 
; Input:        none
; 
; Output:       none
; 
; Misc:
; ******************************************************************************/
; void ADStart(void)
; {
	.dbline 1181
;   ADCSRA |= (1<<ADSC);
	sbi 0x6,6
	.dbline -2
L253:
	.dbline 0 ; func end
	ret
	.dbend
	.area vector(rom, abs)
	.org 64
	jmp _ADDone
	.area text(rom, con, rel)
	.dbfile C:\DATA\InterComm\CODENE~1\InterComm.c
	.dbfunc e ADDone _ADDone fV
	.even
_ADDone::
	xcall push_lset
	.dbline -1
	.dbline 1199
; }
; 
; /******************************************************************************
; 
; Name:         void ADDone(void)
; 
; Description:  This function is automaticaly called when the AD had finish
;               is convertion
; 
; Input:        none
; 
; Output:       none
; 
; Misc:
; ******************************************************************************/
; #pragma interrupt_handler ADDone:17
; void ADDone(void)
; {
	.dbline 1200
;   if (InterCommMode != OFF) NetWriteByte(ADCH);
	lds R2,_InterCommMode
	tst R2
	breq L255
X109:
	.dbline 1200
	in R16,0x5
	xcall _NetWriteByte
L255:
	.dbline -2
L254:
	.dbline 0 ; func end
	xcall pop_lset
	reti
	.dbend
	.dbfunc e VoiceEnginInit _VoiceEnginInit fV
	.even
_VoiceEnginInit::
	.dbline -1
	.dbline 1216
; }
; 
; /******************************************************************************
; 
; Name:         void VoiceEnginInit(void)
; 
; Description:  This function initialize the voice digitalizer and reproducer
; 
; Input:        none
; 
; Output:       none
; 
; Misc:
; ******************************************************************************/
; void VoiceEnginInit(void)
; {
	.dbline 1217
;   DataOutBufferRead = &DataOutBuffer[0];
	ldi R24,<_DataOutBuffer
	ldi R25,>_DataOutBuffer
	sts _DataOutBufferRead+1,R25
	sts _DataOutBufferRead,R24
	.dbline 1218
;   DataOutBufferWrite = &DataOutBuffer[0];
	sts _DataOutBufferWrite+1,R25
	sts _DataOutBufferWrite,R24
	.dbline 1219
;   DataOutBufferQte = 0;
	clr R2
	clr R3
	sts _DataOutBufferQte+1,R3
	sts _DataOutBufferQte,R2
	.dbline 1221
; 
;   DataInBufferRead = &DataInBuffer[0];
	ldi R24,<_DataInBuffer
	ldi R25,>_DataInBuffer
	sts _DataInBufferRead+1,R25
	sts _DataInBufferRead,R24
	.dbline 1222
;   DataInBufferWrite = &DataInBuffer[0];
	sts _DataInBufferWrite+1,R25
	sts _DataInBufferWrite,R24
	.dbline 1223
;   DataInBufferQte = 0;
	sts _DataInBufferQte+1,R3
	sts _DataInBufferQte,R2
	.dbline 1225
;   
;   InterCommMode = OFF;
	sts _InterCommMode,R2
	.dbline 1227
;   
;   TCCR0 = 0x00; //stop
	out 0x33,R2
	.dbline 1228
;   ASSR  = 0x00; //set async mode
	out 0x22,R2
	.dbline 1229
;   TCNT0 = 0x9C; //set count 20k
	ldi R24,156
	out 0x32,R24
	.dbline 1230
;   OCR0  = 0x64;
	ldi R24,100
	out 0x3c,R24
	.dbline 1231
;   OCR1AL = 0x7f;
	ldi R24,127
	out 0x2a,R24
	.dbline 1232
;   OCR1BL = 0xff;
	ldi R24,255
	out 0x28,R24
	.dbline 1233
;   TCCR0 = 0x02; //start timer for 8khz sampling
	ldi R24,2
	out 0x33,R24
	.dbline 1234
;   TIMSK |= 0x01; //timer interrupt sources
	in R24,0x39
	ori R24,1
	out 0x39,R24
	.dbline 1236
; 
;   TCCR1A = (1<<COM1A1) + (1<<COM1B1) + (1<<WGM10);
	ldi R24,161
	out 0x2f,R24
	.dbline 1237
;   TCCR1B = (1<<WGM12) + (1<<CS10);
	ldi R24,9
	out 0x2e,R24
	.dbline 1238
;   DDRD |= PWM_VOICE + PWM_VOLUME + AMPLI_STANDBY;
	in R24,0x11
	ori R24,112
	out 0x11,R24
	.dbline 1239
;   PORTD &= ~AMPLI_STANDBY;
	cbi 0x12,6
	.dbline -2
L257:
	.dbline 0 ; func end
	ret
	.dbend
	.area vector(rom, abs)
	.org 44
	jmp _VoiceEngin
	.area text(rom, con, rel)
	.dbfile C:\DATA\InterComm\CODENE~1\InterComm.c
	.area data(ram, con, rel)
	.dbfile C:\DATA\InterComm\CODENE~1\InterComm.c
L259:
	.blkb 1
	.area idata
	.byte 0
	.area data(ram, con, rel)
	.dbfile C:\DATA\InterComm\CODENE~1\InterComm.c
	.area text(rom, con, rel)
	.dbfile C:\DATA\InterComm\CODENE~1\InterComm.c
	.dbfunc e VoiceEngin _VoiceEngin fV
	.dbsym s i L259 c
	.even
_VoiceEngin::
	xcall push_lset
	st -y,R10
	st -y,R11
	.dbline -1
	.dbline 1256
; }
; 
; /******************************************************************************
; 
; Name:         void DataEngin(void)
; 
; Description:  This function analyse data stream
; 
; Input:        none
; 
; Output:       none
; 
; Misc:
; ******************************************************************************/
; #pragma interrupt_handler VoiceEngin:12
; void VoiceEngin(void)
; {
	.dbline 1258
;   static ushort i = 0;
;   TCNT0 = 0x9c; //reload counter value 20k
	ldi R24,156
	out 0x32,R24
	.dbline 1260
; 
;   if (InterCommMode == TALK) ADStart();
	lds R24,_InterCommMode
	cpi R24,1
	brne L260
X110:
	.dbline 1260
	xcall _ADStart
L260:
	.dbline 1262
; 
;   if (InterCommMode == LISTEN)
	lds R24,_InterCommMode
	cpi R24,2
	brne L262
X111:
	.dbline 1263
;   {
	.dbline 1264
;     if (NetGetInByteCount() != 0) OCR1AL = NetReadByte();
	xcall _NetGetInByteCount
	tst R16
	breq L263
X112:
	.dbline 1264
	xcall _NetReadByte
	out 0x2a,R16
	.dbline 1265
;   }
	xjmp L263
L262:
	.dbline 1266
;   else if (InterCommMode == TONE) OCR1AL = SineTable[i+=Tone];
	lds R24,_InterCommMode
	cpi R24,3
	brne L266
X113:
	.dbline 1266
	lds R2,_Tone
	lds R10,L259
	add R10,R2
	sts L259,R10
	ldi R24,<_SineTable
	ldi R25,>_SineTable
	mov R30,R10
	clr R31
	add R30,R24
	adc R31,R25
	lpm R2,Z
	out 0x2a,R2
	xjmp L267
L266:
	.dbline 1267
;   else OCR1AL = 0x7f;
	ldi R24,127
	out 0x2a,R24
L267:
L263:
	.dbline -2
L258:
	.dbline 0 ; func end
	ld R11,y+
	ld R10,y+
	xcall pop_lset
	reti
	.dbend
	.dbfunc e VoiceVolume _VoiceVolume fV
;            Vol -> R16
	.even
_VoiceVolume::
	.dbline -1
	.dbline 1283
; }
; 
; /******************************************************************************
; 
; Name:         void VoiceVolume(ushort Vol)
; 
; Description:  This function set the output volume
; 
; Input:        ushort -> Volume
; 
; Output:       none
; 
; Misc:
; ******************************************************************************/
; void VoiceVolume(ushort Vol)
; {
	.dbline 1284
;   if (Vol == 0) PORTD &= ~AMPLI_STANDBY;
	tst R16
	brne L269
X114:
	.dbline 1284
	cbi 0x12,6
	xjmp L270
L269:
	.dbline 1285
;   else PORTD |= AMPLI_STANDBY;
	sbi 0x12,6
L270:
	.dbline 1286
;   OCR1BL = Vol;
	out 0x28,R16
	.dbline -2
L268:
	.dbline 0 ; func end
	ret
	.dbsym r Vol 16 c
	.dbend
	.dbfunc e NetInit _NetInit fV
	.even
_NetInit::
	.dbline -1
	.dbline 1305
; }
; 
; //*****************************************************************************
; //        N E T W O R K     F U N C T I O N
; //*****************************************************************************
; /******************************************************************************
; 
; Name:         void NetInit(void)
; 
; Description:  This function initialize for NET network
; 
; Input:        None
; 
; Output:       None
; 
; Misc:
; ******************************************************************************/
; void NetInit(void)
; {
	.dbline 1306
;   NET_UBRRH = 0x00;                               //set baud rate hi
	clr R2
	out 0x20,R2
	.dbline 1307
;   NET_UBRRL = (XTAL / (16 * NET_SPEED)) - 1;      //set baud rate
	ldi R24,1
	out 0x9,R24
	.dbline 1308
;   NET_UCSRA = (1<<MPCM);
	out 0xb,R24
	.dbline 1309
;   NET_UCSRB = (1<<UCSZ2) + (1<<RXCIE)+(1<<RXEN)+(1<<TXEN);
	ldi R24,156
	out 0xa,R24
	.dbline 1310
;   NET_UCSRC = (1<<URSEL) + (1<<UCSZ1) + (1<<UCSZ0);
	ldi R24,134
	out 0x20,R24
	.dbline 1311
;   NET_DDR |= NET_TX;
	sbi 0x11,1
	.dbline 1312
;   NetGetAddress();
	xcall _NetGetAddress
	.dbline -2
L271:
	.dbline 0 ; func end
	ret
	.dbend
	.dbfunc e NetSendCommand _NetSendCommand fV
;        Command -> R10
;             To -> R12
	.even
_NetSendCommand::
	xcall push_xgset003C
	mov R10,R18
	mov R12,R16
	.dbline -1
	.dbline 1330
; }
; 
; /******************************************************************************
; 
; Name:         void NetSendCommand(ushort To,ushort Command)
; 
; Description:  This send a command to another node
; 
; 
; Input:        ushort To
;               ushort Command
; 
; Output:       
; 
; Misc:
; ******************************************************************************/
; void NetSendCommand(ushort To,ushort Command)
; {
	.dbline 1331
;   InterCommMode = OFF;
	clr R2
	sts _InterCommMode,R2
	.dbline 1332
;   NET_UCSRA |= (1<<MPCM);
	sbi 0xb,0
	.dbline 1333
;   DataInBufferQte = 0;
	clr R3
	sts _DataInBufferQte+1,R3
	sts _DataInBufferQte,R2
	.dbline 1334
;   DataOutBufferQte = 0;
	sts _DataOutBufferQte+1,R3
	sts _DataOutBufferQte,R2
	xjmp L274
L273:
	.dbline 1335
;   while (!(NET_UCSRA & (1 << UDRE))) WDR();  // Wait for empty transmit buffer
	wdr
L274:
	.dbline 1335
	sbis 0xb,5
	rjmp L273
X115:
	.dbline 1336
;   NET_UCSRB |= (1<<TXB8);
	sbi 0xa,0
	.dbline 1337
;   NetDirectWriteByte(To);
	mov R16,R12
	xcall _NetDirectWriteByte
	.dbline 1338
;   NET_UCSRB &= ~(1<<TXB8);
	cbi 0xa,0
	.dbline 1339
;   NetDirectWriteByte(Command);
	mov R16,R10
	xcall _NetDirectWriteByte
	.dbline -2
L272:
	.dbline 0 ; func end
	xjmp pop_xgset003C
	.dbsym r Command 10 c
	.dbsym r To 12 c
	.dbend
	.dbfunc e NetDirectWriteByte _NetDirectWriteByte fV
;           Byte -> R16
	.even
_NetDirectWriteByte::
	.dbline -1
	.dbline 1356
; }
; 
; /******************************************************************************
; 
; Name:         void NetDirectWriteByte(ushort Byte)
; 
; Description:  This function write a byte directly in the serial port
; 
; 
; Input:        none
; 
; Output:       
; 
; Misc:
; ******************************************************************************/
; void NetDirectWriteByte(ushort Byte)
; {
	.dbline 1357
;   NET_UDR = Byte;
	out 0xc,R16
	xjmp L278
L277:
	.dbline 1358
;   while (!(NET_UCSRA & (1 << UDRE))) WDR();  // Wait for empty transmit buffer
	wdr
L278:
	.dbline 1358
	sbis 0xb,5
	rjmp L277
X116:
	.dbline -2
L276:
	.dbline 0 ; func end
	ret
	.dbsym r Byte 16 c
	.dbend
	.dbfunc e NetWriteByte _NetWriteByte fV
;           Byte -> R16
	.even
_NetWriteByte::
	.dbline -1
	.dbline 1375
; }
; 
; /******************************************************************************
; 
; Name:         void NetWriteByte(ushort Byte)
; 
; Description:  This function write a byte in the TX buffer
; 
; 
; Input:        none
; 
; Output:       
; 
; Misc:
; ******************************************************************************/
; void NetWriteByte(ushort Byte)
; {
	.dbline 1376
;   if (DataOutBufferQte++ > VOICEBUFFER)
	lds R2,_DataOutBufferQte
	lds R3,_DataOutBufferQte+1
	movw R24,R2
	adiw R24,1
	sts _DataOutBufferQte+1,R25
	sts _DataOutBufferQte,R24
	ldi R24,64
	ldi R25,0
	cp R24,R2
	cpc R25,R3
	brsh L281
X117:
	.dbline 1377
;   {
	.dbline 1378
;     DataOutBufferQte = 0;
	clr R2
	clr R3
	sts _DataOutBufferQte+1,R3
	sts _DataOutBufferQte,R2
	.dbline 1379
;     DataOutBufferWrite = &DataOutBuffer[0];
	ldi R24,<_DataOutBuffer
	ldi R25,>_DataOutBuffer
	sts _DataOutBufferWrite+1,R25
	sts _DataOutBufferWrite,R24
	.dbline 1380
;     DataOutBufferRead = &DataOutBuffer[0];
	sts _DataOutBufferRead+1,R25
	sts _DataOutBufferRead,R24
	.dbline 1381
;   }
L281:
	.dbline 1383
; 
;   *DataOutBufferWrite++ = Byte;
	lds R30,_DataOutBufferWrite
	lds R31,_DataOutBufferWrite+1
	st Z+,R16
	sts _DataOutBufferWrite+1,R31
	sts _DataOutBufferWrite,R30
	.dbline 1384
;   if (DataOutBufferWrite > &DataOutBuffer[VOICEBUFFER-1])
	ldi R24,<_DataOutBuffer+63
	ldi R25,>_DataOutBuffer+63
	cp R24,R30
	cpc R25,R31
	brsh L283
X118:
	.dbline 1385
;   {
	.dbline 1386
;     DataOutBufferWrite = &DataOutBuffer[0];
	ldi R24,<_DataOutBuffer
	ldi R25,>_DataOutBuffer
	sts _DataOutBufferWrite+1,R25
	sts _DataOutBufferWrite,R24
	.dbline 1387
;   }
L283:
	.dbline 1388
;   NET_UCSRB |= (1<<UDRIE);
	sbi 0xa,5
	.dbline -2
L280:
	.dbline 0 ; func end
	ret
	.dbsym r Byte 16 c
	.dbend
	.dbfunc e NetReadByte _NetReadByte fc
;           Byte -> R16
	.even
_NetReadByte::
	.dbline -1
	.dbline 1405
; }
; 
; /******************************************************************************
; 
; Name:         ushort NetReadByte(void)
; 
; Description:  This function read a byte in the RX buffer
; 
; 
; Input:        none
; 
; Output:       
; 
; Misc:
; ******************************************************************************/
; ushort NetReadByte(void)
; {
	.dbline 1406
;   ushort Byte = 0x00;
	clr R16
	.dbline 1408
; 
;   if (DataInBufferQte != 0)
	lds R2,_DataInBufferQte
	lds R3,_DataInBufferQte+1
	tst R2
	brne X119
	tst R3
	breq L287
X119:
	.dbline 1409
;   {
	.dbline 1410
;     DataInBufferQte--;
	movw R24,R2
	sbiw R24,1
	sts _DataInBufferQte+1,R25
	sts _DataInBufferQte,R24
	.dbline 1411
;     Byte = *DataInBufferRead++;
	lds R30,_DataInBufferRead
	lds R31,_DataInBufferRead+1
	ld R16,Z+
	sts _DataInBufferRead+1,R31
	sts _DataInBufferRead,R30
	.dbline 1412
;     if (DataInBufferRead > &DataInBuffer[VOICEBUFFER-1])
	ldi R24,<_DataInBuffer+63
	ldi R25,>_DataInBuffer+63
	cp R24,R30
	cpc R25,R31
	brsh L289
X120:
	.dbline 1413
;     {
	.dbline 1414
;       DataInBufferRead = &DataInBuffer[0];
	ldi R24,<_DataInBuffer
	ldi R25,>_DataInBuffer
	sts _DataInBufferRead+1,R25
	sts _DataInBufferRead,R24
	.dbline 1415
;     }
L289:
	.dbline 1416
;   }
L287:
	.dbline 1417
;   return Byte;
	.dbline -2
L286:
	.dbline 0 ; func end
	ret
	.dbsym r Byte 16 c
	.dbend
	.dbfunc e NetGetInByteCount _NetGetInByteCount fc
	.even
_NetGetInByteCount::
	.dbline -1
	.dbline 1434
; }
; 
; /******************************************************************************
; 
; Name:         ushort NetGetInByteCount(void)
; 
; Description:  This function return the Qte of byte in the RX buffer
; 
; 
; Input:        none
; 
; Output:       
; 
; Misc:
; ******************************************************************************/
; ushort NetGetInByteCount(void)
; {
	.dbline 1435
;   return DataInBufferQte; 
	lds R16,_DataInBufferQte
	.dbline -2
L292:
	.dbline 0 ; func end
	ret
	.dbend
	.area vector(rom, abs)
	.org 52
	jmp _NetRxByte
	.area text(rom, con, rel)
	.dbfile C:\DATA\InterComm\CODENE~1\InterComm.c
	.area bss(ram, con, rel)
	.dbfile C:\DATA\InterComm\CODENE~1\InterComm.c
L294:
	.blkb 1
	.area data(ram, con, rel)
	.dbfile C:\DATA\InterComm\CODENE~1\InterComm.c
L295:
	.blkb 1
	.area idata
	.byte 0
	.area data(ram, con, rel)
	.dbfile C:\DATA\InterComm\CODENE~1\InterComm.c
	.area text(rom, con, rel)
	.dbfile C:\DATA\InterComm\CODENE~1\InterComm.c
	.dbfunc e NetRxByte _NetRxByte fV
	.dbsym s Command L295 c
	.dbsym s InByte L294 c
	.even
_NetRxByte::
	xcall push_lset
	.dbline -1
	.dbline 1454
; }
; 
; /******************************************************************************
; 
; Name:         void NetRxByte(void)
; 
; Description:  This function is automaticaly called each
;               time a char is received on the NET bus.
; 
; 
; Input:        none
; 
; Output:       
; 
; Misc:
; ******************************************************************************/
; #pragma interrupt_handler NetRxByte:14
; void NetRxByte(void)
; {
	.dbline 1458
;   static ushort InByte;
;   static ushort Command = FALSE;
; 
;   if (NET_UCSRA & ((1<<FE)+(1<<DOR)))
	in R24,0xb
	andi R24,24
	breq L296
X121:
	.dbline 1459
;   {
	.dbline 1460
;     InByte = NET_UDR;
	in R2,0xc
	sts L294,R2
	.dbline 1461
;     return;
	xjmp L293
L296:
	.dbline 1464
;   }
;   
;   if (NET_UCSRB & 0x02)
	sbis 0xa,1
	rjmp L298
X122:
	.dbline 1465
;   {
	.dbline 1466
;     InByte = NET_UDR;
	in R2,0xc
	sts L294,R2
	.dbline 1467
;     if ((InByte == NetAddress) || ((InByte == 0xfe) && (BroadCastEnable == TRUE)) || (InByte == 0xff))
	mov R3,R2
	lds R2,_NetAddress
	cp R3,R2
	breq L303
X123:
	mov R24,R3
	cpi R24,254
	brne L304
X124:
	lds R24,_BroadCastEnable
	cpi R24,1
	breq L303
X125:
L304:
	lds R24,L294
	cpi R24,255
	brne L300
X126:
L303:
	.dbline 1468
;     {
	.dbline 1469
;       NET_UCSRA &= ~(1<<MPCM);
	cbi 0xb,0
	.dbline 1470
;       Command = TRUE;
	ldi R24,1
	sts L295,R24
	.dbline 1471
;       return;
	xjmp L293
L300:
	.dbline 1474
;     }
;     else
;     {
	.dbline 1475
;       NET_UCSRA |= (1<<MPCM);
	sbi 0xb,0
	.dbline 1476
;       Command = FALSE;
	clr R2
	sts L295,R2
	.dbline 1477
;       return;
	xjmp L293
L298:
	.dbline 1481
;     }
;   }
; 
;   else if (Command == TRUE)
	lds R24,L295
	cpi R24,1
	brne L305
X127:
	.dbline 1482
;   {
	.dbline 1483
;     Command = FALSE;
	clr R2
	sts L295,R2
	.dbline 1484
;     InByte = NET_UDR;
	in R2,0xc
	sts L294,R2
	.dbline 1486
; 
;     if (InByte == OFF)
	tst R2
	brne L307
X128:
	.dbline 1487
;     {
	.dbline 1488
;       InterCommMode = OFF;
	clr R2
	sts _InterCommMode,R2
	.dbline 1489
;       IncommingCall = FALSE;
	sts _IncommingCall,R2
	.dbline 1490
;       VoiceVolume(0);
	clr R16
	xcall _VoiceVolume
	.dbline 1491
;     }
	xjmp L293
L307:
	.dbline 1493
; 
;     else if (InByte == TALK)
	lds R24,L294
	cpi R24,1
	brne L309
X129:
	.dbline 1494
;     {
	.dbline 1495
;       IncommingCall = TRUE;
	ldi R24,1
	sts _IncommingCall,R24
	.dbline 1496
;       InterCommMode = TALK;
	sts _InterCommMode,R24
	.dbline 1497
;     }
	xjmp L293
L309:
	.dbline 1499
; 
;     else if (InByte == LISTEN)
	lds R24,L294
	cpi R24,2
	brne L311
X130:
	.dbline 1500
;     {
	.dbline 1501
;       VoiceVolume(Volume);
	lds R16,_Volume
	xcall _VoiceVolume
	.dbline 1502
;       IncommingCall = TRUE;
	ldi R24,1
	sts _IncommingCall,R24
	.dbline 1503
;       InterCommMode = LISTEN;
	ldi R24,2
	sts _InterCommMode,R24
	.dbline 1504
;     }
	xjmp L293
L311:
	.dbline 1506
; 
;     else if (InByte == BUSY)
	lds R24,L294
	cpi R24,4
	brne L293
X131:
	.dbline 1507
;     {
	.dbline 1508
;       InterCommMode = BUSY;
	ldi R24,4
	sts _InterCommMode,R24
	.dbline 1509
;     }
	.dbline 1510
;     return;
	xjmp L293
L305:
	.dbline 1513
;   }
; 
;   if (DataInBufferQte++ > VOICEBUFFER)
	lds R2,_DataInBufferQte
	lds R3,_DataInBufferQte+1
	movw R24,R2
	adiw R24,1
	sts _DataInBufferQte+1,R25
	sts _DataInBufferQte,R24
	ldi R24,64
	ldi R25,0
	cp R24,R2
	cpc R25,R3
	brsh L315
X132:
	.dbline 1514
;   {
	.dbline 1515
;     DataInBufferQte = 0;
	clr R2
	clr R3
	sts _DataInBufferQte+1,R3
	sts _DataInBufferQte,R2
	.dbline 1516
;     DataInBufferWrite = &DataInBuffer[0];
	ldi R24,<_DataInBuffer
	ldi R25,>_DataInBuffer
	sts _DataInBufferWrite+1,R25
	sts _DataInBufferWrite,R24
	.dbline 1517
;     DataInBufferRead = &DataInBuffer[0];
	sts _DataInBufferRead+1,R25
	sts _DataInBufferRead,R24
	.dbline 1518
;   }
L315:
	.dbline 1519
;   *DataInBufferWrite++ = NET_UDR;;
	in R2,0xc
	lds R30,_DataInBufferWrite
	lds R31,_DataInBufferWrite+1
	st Z+,R2
	sts _DataInBufferWrite+1,R31
	sts _DataInBufferWrite,R30
	.dbline 1519
	.dbline 1521
; 
;   if (DataInBufferWrite > &DataInBuffer[VOICEBUFFER-1])
	ldi R24,<_DataInBuffer+63
	ldi R25,>_DataInBuffer+63
	cp R24,R30
	cpc R25,R31
	brsh L317
X133:
	.dbline 1522
;   {
	.dbline 1523
;     DataInBufferWrite = &DataInBuffer[0];
	ldi R24,<_DataInBuffer
	ldi R25,>_DataInBuffer
	sts _DataInBufferWrite+1,R25
	sts _DataInBufferWrite,R24
	.dbline 1524
;   }
L317:
	.dbline -2
L293:
	.dbline 0 ; func end
	xcall pop_lset
	reti
	.dbend
	.area vector(rom, abs)
	.org 56
	jmp _NetTxByte
	.area text(rom, con, rel)
	.dbfile C:\DATA\InterComm\CODENE~1\InterComm.c
	.dbfunc e NetTxByte _NetTxByte fV
	.even
_NetTxByte::
	st -y,R2
	st -y,R3
	st -y,R24
	st -y,R25
	st -y,R30
	st -y,R31
	in R2,0x3f
	st -y,R2
	.dbline -1
	.dbline 1543
; }
; 
; /******************************************************************************
; 
; Name:         void NetTxByte(void)
; 
; Description:  This function is automaticaly called each
;               time a char had been send on the NET bus.
; 
; 
; Input:        none
; 
; Output:       
; 
; Misc:
; ******************************************************************************/
; #pragma interrupt_handler NetTxByte:15
; void NetTxByte(void)
; {
	.dbline 1544
;   if (DataOutBufferQte == 0) NET_UCSRB &= ~(1<<UDRIE); /* TX int empty disable */
	lds R2,_DataOutBufferQte
	lds R3,_DataOutBufferQte+1
	tst R2
	brne L321
	tst R3
	brne L321
X134:
	.dbline 1544
	cbi 0xa,5
	xjmp L322
L321:
	.dbline 1546
;   else
;   {
	.dbline 1547
;     DataOutBufferQte--;
	lds R24,_DataOutBufferQte
	lds R25,_DataOutBufferQte+1
	sbiw R24,1
	sts _DataOutBufferQte+1,R25
	sts _DataOutBufferQte,R24
	.dbline 1548
;     NET_UDR = *DataOutBufferRead++;
	lds R30,_DataOutBufferRead
	lds R31,_DataOutBufferRead+1
	ld R2,Z+
	sts _DataOutBufferRead+1,R31
	sts _DataOutBufferRead,R30
	out 0xc,R2
	.dbline 1549
;     if (DataOutBufferRead > &DataOutBuffer[VOICEBUFFER-1])
	ldi R24,<_DataOutBuffer+63
	ldi R25,>_DataOutBuffer+63
	cp R24,R30
	cpc R25,R31
	brsh L323
X135:
	.dbline 1550
;     {
	.dbline 1551
;       DataOutBufferRead = &DataOutBuffer[0];
	ldi R24,<_DataOutBuffer
	ldi R25,>_DataOutBuffer
	sts _DataOutBufferRead+1,R25
	sts _DataOutBufferRead,R24
	.dbline 1552
;     }
L323:
	.dbline 1553
;   }
L322:
	.dbline -2
L320:
	.dbline 0 ; func end
	ld R2,y+
	out 0x3f,R2
	ld R31,y+
	ld R30,y+
	ld R25,y+
	ld R24,y+
	ld R3,y+
	ld R2,y+
	reti
	.dbend
	.dbfunc e NetGetAddress _NetGetAddress fV
	.even
_NetGetAddress::
	.dbline -1
	.dbline 1571
; }
; 
; /******************************************************************************
; 
; Name:         void NetGetAddress(void)
; 
; Description:  Get the network address of this node
;               from dip switch
; 
; Input:        None
; 
; Output:       None
; 
; Misc:
; 
; ******************************************************************************/
; void NetGetAddress(void)
; {
	.dbline 1572
;   NetAddress = NET_GET_ADDRESS;
	ldi R16,2
	ldi R17,0
	xcall _EEPROMread
	sts _NetAddress,R16
	.dbline 1572
	.dbline -2
L326:
	.dbline 0 ; func end
	ret
	.dbend
	.dbfunc e LCDCreateCHR _LCDCreateCHR fV
;              i -> R10
;              j -> R20
;            ptr -> R12,R13
;       chnumber -> R10
	.even
_LCDCreateCHR::
	xcall push_xgset303C
	movw R12,R18
	mov R10,R16
	.dbline -1
	.dbline 1593
; }
; 
; //*****************************************************************************
; // LCD Code
; //*****************************************************************************
; /******************************************************************************
; 
; Name:         LCDCreateCHR
; 
; Description:  Create a new char in CGRAM
; 
; Input:        ushort  : Character number (0-7)
;               *ushort : 7 ushort containing the data
; 
; Output:       none
; 
; Misc:
; 
; ******************************************************************************/
; void LCDCreateCHR(ushort chnumber, char *ptr)
; {
	.dbline 1596
;   ushort i,j;
; 
;   i = 8 * chnumber;
	ldi R24,8
	mul R24,R10
	mov R10,R0
	.dbline 1598
; 
;   for (j=0;j<8;j++)
	clr R20
	xjmp L331
L328:
	.dbline 1599
;   {
	.dbline 1600
;     LCDWriteData(LCD_CTRL,(0x40 | (i + j)));
	mov R18,R10
	add R18,R20
	ori R18,64
	clr R16
	xcall _LCDWriteData
	.dbline 1601
;     LCDWriteData(LCD_DATA,ptr[j]);
	mov R30,R20
	clr R31
	add R30,R12
	adc R31,R13
	ldd R18,z+0
	ldi R16,1
	xcall _LCDWriteData
	.dbline 1602
;   }
L329:
	.dbline 1598
	inc R20
L331:
	.dbline 1598
	cpi R20,8
	brlo L328
X136:
	.dbline -2
L327:
	.dbline 0 ; func end
	xjmp pop_xgset303C
	.dbsym r i 10 c
	.dbsym r j 20 c
	.dbsym r ptr 12 pc
	.dbsym r chnumber 10 c
	.dbend
	.dbfunc e LCDClrSCR _LCDClrSCR fV
	.even
_LCDClrSCR::
	.dbline -1
	.dbline 1620
; }
; 
; 
; /******************************************************************************
; 
; Name:         void LCDClrSCR(void)
; 
; Description:  Clear the LCD
; 
; Input:        none
; 
; Output:       none
; 
; Misc:
; 
; ******************************************************************************/
; void LCDClrSCR(void)
; {
	.dbline 1621
;   LCDWait();
	xcall _LCDWait
	.dbline 1622
;   LCDWriteData(LCD_CTRL,0x01);      // Clear display
	ldi R18,1
	clr R16
	xcall _LCDWriteData
	.dbline -2
L332:
	.dbline 0 ; func end
	ret
	.dbend
	.dbfunc e LCDGotoXY _LCDGotoXY fV
;        address -> R20
;              y -> R10
;              x -> R22
	.even
_LCDGotoXY::
	xcall push_xgsetF03C
	mov R10,R18
	mov R22,R16
	.dbline -1
	.dbline 1640
; }
; 
; /******************************************************************************
; 
; Name:         LCDGotoXY(ushort x, ushort y)
; 
; Description:  Position cursor on the LCD at X & Y location
; 
; Input:        X -> X position on the LCD
;               Y -> Y position on the LCD
; 
; Output:       none
; 
; Misc:
; 
; ******************************************************************************/
; void LCDGotoXY(ushort x,ushort y)
; {
	.dbline 1643
;   ushort address;
; 
;   x--;
	dec R22
	.dbline 1645
; 
;   if (MaxY < 3)
	lds R24,_MaxY
	cpi R24,3
	brsh L334
X137:
	.dbline 1646
;   {
	.dbline 1647
;     switch(y)
	mov R12,R10
	clr R13
	movw R24,R12
	cpi R24,1
	ldi R30,0
	cpc R25,R30
	breq L339
X138:
	cpi R24,2
	ldi R30,0
	cpc R25,R30
	breq L340
X139:
	xjmp L335
L339:
	.dbline 1650
;     {
;       case '\x01' :
;       address = 0 + x;
	mov R20,R22
	.dbline 1651
;       break;
	xjmp L335
L340:
	.dbline 1653
;       case '\x02' :
;       address = 64 + x;
	mov R20,R22
	subi R20,192    ; addi 64
	.dbline 1654
;       break;
	.dbline 1656
;     }
;   }
	xjmp L335
L334:
	.dbline 1658
;   else
;   {
	.dbline 1659
;     switch(y)
	clr R11
	movw R24,R10
	cpi R24,1
	ldi R30,0
	cpc R25,R30
	breq L344
X140:
	cpi R24,2
	ldi R30,0
	cpc R25,R30
	breq L345
X141:
	cpi R24,3
	ldi R30,0
	cpc R25,R30
	breq L346
X142:
	cpi R24,4
	ldi R30,0
	cpc R25,R30
	breq L347
X143:
	xjmp L341
L344:
	.dbline 1662
;     {
;       case '\x01' :
;       address = 0 + x;
	mov R20,R22
	.dbline 1663
;       break;
	xjmp L342
L345:
	.dbline 1665
;       case '\x02' :
;       address = 64 + x;
	mov R20,R22
	subi R20,192    ; addi 64
	.dbline 1666
;       break;
	xjmp L342
L346:
	.dbline 1668
;       case '\x03' :
;       address = 20 + x;
	mov R20,R22
	subi R20,236    ; addi 20
	.dbline 1669
;       break;
	xjmp L342
L347:
	.dbline 1671
;       case '\x04' :
;       address = 84 + x;
	mov R20,R22
	subi R20,172    ; addi 84
	.dbline 1672
;       break;
L341:
L342:
	.dbline 1674
;     }
;   }
L335:
	.dbline 1675
;   LCDWriteData(LCD_CTRL,address | 0x80);
	mov R18,R20
	ori R18,128
	clr R16
	xcall _LCDWriteData
	.dbline -2
L333:
	.dbline 0 ; func end
	xjmp pop_xgsetF03C
	.dbsym r address 20 c
	.dbsym r y 10 c
	.dbsym r x 22 c
	.dbend
	.dbfunc e LCDWhereX _LCDWhereX fc
;              i -> R22
;              y -> R10
;              x -> R20
	.even
_LCDWhereX::
	xcall push_xgsetF00C
	.dbline -1
	.dbline 1692
; }
; 
; /******************************************************************************
; 
; Name:         LCDWhereX
; 
; Description:  Get the x position of the cursor on the LCD
; 
; Input:        None
; 
; Output:       ushort : Cursor position "x"
; 
; Misc:
; 
; ******************************************************************************/
; ushort LCDWhereX(void)
; {
	.dbline 1695
; ushort i,x,y;
; 
; i = LCDReadData(LCD_CTRL) & 0x7f;
	clr R16
	xcall _LCDReadData
	mov R22,R16
	andi R22,127
	.dbline 1697
; 
; y = LCDWhereY();
	xcall _LCDWhereY
	mov R10,R16
	.dbline 1699
; 
; if (MaxY == 2)
	lds R24,_MaxY
	cpi R24,2
	brne L349
X144:
	.dbline 1700
;     {
	.dbline 1701
;     if (y == 1) x = i;
	cpi R16,1
	brne L351
X145:
	.dbline 1701
	mov R20,R22
L351:
	.dbline 1702
;     if (y == 2) x = i - 0x40;
	mov R24,R10
	cpi R24,2
	brne L350
X146:
	.dbline 1702
	mov R20,R22
	subi R20,64
	.dbline 1703
;     }
	xjmp L350
L349:
	.dbline 1704
; else if (MaxY == 4)
	lds R24,_MaxY
	cpi R24,4
	brne L355
X147:
	.dbline 1705
;     {
	.dbline 1706
;     if (y == 1) x = i;
	mov R24,R10
	cpi R24,1
	brne L357
X148:
	.dbline 1706
	mov R20,R22
L357:
	.dbline 1707
;     if (y == 2) x = i - 0x40;
	mov R24,R10
	cpi R24,2
	brne L359
X149:
	.dbline 1707
	mov R20,R22
	subi R20,64
L359:
	.dbline 1708
;     if (y == 3) x = i - 0x14;
	mov R24,R10
	cpi R24,3
	brne L361
X150:
	.dbline 1708
	mov R20,R22
	subi R20,20
L361:
	.dbline 1709
;     if (y == 4) x = i - 0x54;
	mov R24,R10
	cpi R24,4
	brne L363
X151:
	.dbline 1709
	mov R20,R22
	subi R20,84
L363:
	.dbline 1710
;     }
L355:
L350:
	.dbline 1711
; x = x + 1;
	inc R20
	.dbline 1712
; return x;
	mov R16,R20
	.dbline -2
L348:
	.dbline 0 ; func end
	xjmp pop_xgsetF00C
	.dbsym r i 22 c
	.dbsym r y 10 c
	.dbsym r x 20 c
	.dbend
	.dbfunc e LCDWhereY _LCDWhereY fc
;              j -> R20
;              i -> R22
	.even
_LCDWhereY::
	xcall push_xgsetF000
	.dbline -1
	.dbline 1729
; }
; 
; /******************************************************************************
; 
; Name:         LCDWhereY
; 
; Description:  Get the y position of the cursor on the LCD
; 
; Input:        None
; 
; Output:       ushort : Cursor position "y"
; 
; Misc:
; 
; ******************************************************************************/
; ushort LCDWhereY(void)
; {
	.dbline 1732
;   ushort i,j;
; 
;   i = LCDReadData(LCD_CTRL) & 0x7f;
	clr R16
	xcall _LCDReadData
	mov R22,R16
	andi R22,127
	.dbline 1734
; 
;   if (MaxY == 2)
	lds R24,_MaxY
	cpi R24,2
	brne L366
X152:
	.dbline 1735
;   {
	.dbline 1736
;     if (i < 0x28) j = 1;
	cpi R22,40
	brsh L368
X153:
	.dbline 1736
	ldi R20,1
	xjmp L367
L368:
	.dbline 1737
;     else j = 2;
	ldi R20,2
	.dbline 1738
;   }
	xjmp L367
L366:
	.dbline 1739
;   else if (MaxY == 4)
	lds R24,_MaxY
	cpi R24,4
	brne L370
X154:
	.dbline 1740
;   {
	.dbline 1741
;     if ((i >0x00) && (i < 0x15)) j = 1;
	ldi R24,0
	cp R24,R22
	brsh L372
X155:
	cpi R22,21
	brsh L372
X156:
	.dbline 1741
	ldi R20,1
L372:
	.dbline 1742
;     if ((i >0x14) && (i < 0x28)) j = 3;
	ldi R24,20
	cp R24,R22
	brsh L374
X157:
	cpi R22,40
	brsh L374
X158:
	.dbline 1742
	ldi R20,3
L374:
	.dbline 1743
;     if ((i >0x40) && (i < 0x55)) j = 2;
	ldi R24,64
	cp R24,R22
	brsh L376
X159:
	cpi R22,85
	brsh L376
X160:
	.dbline 1743
	ldi R20,2
L376:
	.dbline 1744
;     if ((i >0x54) && (i < 0x68)) j = 4;
	ldi R24,84
	cp R24,R22
	brsh L378
X161:
	cpi R22,104
	brsh L378
X162:
	.dbline 1744
	ldi R20,4
L378:
	.dbline 1745
;   }
L370:
L367:
	.dbline 1746
;   return j;
	mov R16,R20
	.dbline -2
L365:
	.dbline 0 ; func end
	xjmp pop_xgsetF000
	.dbsym r j 20 c
	.dbsym r i 22 c
	.dbend
	.dbfunc e LCDWriteChar _LCDWriteChar fV
;            tmp -> R20
;           byte -> R22
	.even
_LCDWriteChar::
	xcall push_xgsetF000
	mov R22,R16
	.dbline -1
	.dbline 1763
; }
; 
; /******************************************************************************
; 
; Name:         WtireByteLCD(char byte)
; 
; Description:  Write a byte on the LCD at cursor position
; 
; Input:        byte
; 
; Output:       none
; 
; Misc:
; 
; ******************************************************************************/
; void LCDWriteChar(char byte)
; {
	.dbline 1766
;   char tmp;
; 
;   tmp = byte & 0xf0;
	mov R20,R22
	andi R20,240
	.dbline 1767
;   tmp = tmp >> 4;
	mov R24,R20
	swap R24
	andi R24,#0x0F
	mov R20,R24
	.dbline 1768
;   tmp += 0x30;
	subi R20,208    ; addi 48
	.dbline 1769
;   if (tmp > 0x39) tmp += 0x07;
	ldi R24,57
	cp R24,R20
	brsh L381
X163:
	.dbline 1769
	subi R20,249    ; addi 7
L381:
	.dbline 1770
;   LCDWriteData(LCD_DATA,tmp);
	mov R18,R20
	ldi R16,1
	xcall _LCDWriteData
	.dbline 1772
; 
;   tmp = byte & 0x0f;
	mov R20,R22
	andi R20,15
	.dbline 1773
;   tmp += 0x30;
	subi R20,208    ; addi 48
	.dbline 1774
;   if (tmp > 0x39) tmp += 0x07;
	ldi R24,57
	cp R24,R20
	brsh L383
X164:
	.dbline 1774
	subi R20,249    ; addi 7
L383:
	.dbline 1775
;   LCDWriteData(LCD_DATA,tmp);
	mov R18,R20
	ldi R16,1
	xcall _LCDWriteData
	.dbline -2
L380:
	.dbline 0 ; func end
	xjmp pop_xgsetF000
	.dbsym r tmp 20 c
	.dbsym r byte 22 c
	.dbend
	.dbfunc e LCDWriteString _LCDWriteString fV
;              i -> R20
;            ptr -> R10,R11
	.even
_LCDWriteString::
	xcall push_xgset300C
	movw R10,R16
	.dbline -1
	.dbline 1792
; }
; 
; /******************************************************************************
; 
; Name:         void LCDWriteString(char *ptr)
; 
; Description:  Write a string from RAM on the LCD
; 
; Input:        string pointer
; 
; Output:       none
; 
; Misc:
; 
; ******************************************************************************/
; void LCDWriteString(char *ptr)
; {
	.dbline 1795
;   ushort i;
; 
;   for (i=1;i<41;i++)
	ldi R20,1
	xjmp L389
L386:
	.dbline 1796
;   {
	.dbline 1797
;     if (*ptr == 0x00) break;
	movw R30,R10
	ldd R2,z+0
	tst R2
	brne L390
X165:
	.dbline 1797
	xjmp L388
L390:
	.dbline 1798
;     LCDWriteData(LCD_DATA,*ptr++);
	movw R30,R10
	ld R18,Z+
	movw R10,R30
	ldi R16,1
	xcall _LCDWriteData
	.dbline 1799
;   }
L387:
	.dbline 1795
	inc R20
L389:
	.dbline 1795
	cpi R20,41
	brlo L386
X166:
L388:
	.dbline -2
L385:
	.dbline 0 ; func end
	xjmp pop_xgset300C
	.dbsym r i 20 c
	.dbsym r ptr 10 pc
	.dbend
	.dbfunc e LCDWriteConstString _LCDWriteConstString fV
;              i -> R20
;            ptr -> R22,R23
	.even
_LCDWriteConstString::
	xcall push_xgsetF000
	movw R22,R16
	.dbline -1
	.dbline 1816
; }
; 
; /******************************************************************************
; 
; Name:         void LCDWriteConstString(const char *ptr)
; 
; Description:  Write a constant string on the LCD
; 
; Input:        string pointer
; 
; Output:       none
; 
; Misc:
; 
; ******************************************************************************/
; void LCDWriteConstString(const char *ptr)
; {
	.dbline 1819
;   ushort i;
; 
;   for (i=1;i<41;i++)
	ldi R20,1
	xjmp L396
L393:
	.dbline 1820
;   {
	.dbline 1821
;     if (*ptr == 0x00) break;
	movw R30,R22
	lpm R2,Z
	tst R2
	brne L397
X167:
	.dbline 1821
	xjmp L395
L397:
	.dbline 1822
;     else if (i == 21) LCDGotoXY(1,2);
	cpi R20,21
	brne L399
X168:
	.dbline 1822
	ldi R18,2
	ldi R16,1
	xcall _LCDGotoXY
L399:
	.dbline 1823
;     LCDWriteData(LCD_DATA,*ptr++);
	movw R2,R22
	subi R22,255  ; offset = 1
	sbci R23,255
	movw R30,R2
	lpm R18,Z
	ldi R16,1
	xcall _LCDWriteData
	.dbline 1824
;   }
L394:
	.dbline 1819
	inc R20
L396:
	.dbline 1819
	cpi R20,41
	brlo L393
X169:
L395:
	.dbline -2
L392:
	.dbline 0 ; func end
	xjmp pop_xgsetF000
	.dbsym r i 20 c
	.dbsym r ptr 22 pkc
	.dbend
	.dbfunc e LCDWriteData _LCDWriteData fV
;           Stat -> R10
;             ch -> R22
;             rs -> R20
	.even
_LCDWriteData::
	xcall push_xgsetF00C
	mov R22,R18
	mov R20,R16
	.dbline -1
	.dbline 1842
; }
; 
; /******************************************************************************
; 
; Name:         void LCDWriteData(ushort rs, ushort ch)
; 
; Description:  Write a byte in rs of the LCD
; 
; Input:        rs -> Register select
;               ch -> byte to write
; 
; Output:       none
; 
; Misc:
; 
; ******************************************************************************/
; void LCDWriteData(ushort rs,ushort ch)
; {
	.dbline 1845
;   ushort Stat;
;   
;   Stat = LCD_PIN & LCD_BACKLIGHT;
	in R24,0x13
	andi R24,128
	mov R10,R24
	.dbline 1847
; 
;   LCD_PORT = Stat;
	out 0x15,R24
	.dbline 1849
;   
;   LCDWait();
	xcall _LCDWait
	.dbline 1851
; 
;   if ((ch & 0x80) == 0x80) LCD_PORT |= LCD_D7;
	mov R24,R22
	andi R24,128
	cpi R24,128
	brne L402
X170:
	.dbline 1851
	sbi 0x15,0
L402:
	.dbline 1852
;   if ((ch & 0x40) == 0x40) LCD_PORT |= LCD_D6;
	mov R24,R22
	andi R24,64
	cpi R24,64
	brne L404
X171:
	.dbline 1852
	sbi 0x15,1
L404:
	.dbline 1853
;   if ((ch & 0x20) == 0x20) LCD_PORT |= LCD_D5;
	mov R24,R22
	andi R24,32
	cpi R24,32
	brne L406
X172:
	.dbline 1853
	sbi 0x15,2
L406:
	.dbline 1854
;   if ((ch & 0x10) == 0x10) LCD_PORT |= LCD_D4;
	mov R24,R22
	andi R24,16
	cpi R24,16
	brne L408
X173:
	.dbline 1854
	sbi 0x15,3
L408:
	.dbline 1855
;   if (rs == 1) LCD_PORT |= LCD_RS;
	cpi R20,1
	brne L410
X174:
	.dbline 1855
	sbi 0x15,6
L410:
	.dbline 1857
; 
;   LCD_PORT |= LCD_E;
	sbi 0x15,4
	.dbline 1858
;   LCD_PORT &= ~LCD_E;
	cbi 0x15,4
	.dbline 1860
; 
;   LCD_PORT = Stat;
	out 0x15,R10
	.dbline 1861
;   if ((ch & 0x08) == 0x08) LCD_PORT |= LCD_D7;
	mov R24,R22
	andi R24,8
	cpi R24,8
	brne L412
X175:
	.dbline 1861
	sbi 0x15,0
L412:
	.dbline 1862
;   if ((ch & 0x04) == 0x04) LCD_PORT |= LCD_D6;
	mov R24,R22
	andi R24,4
	cpi R24,4
	brne L414
X176:
	.dbline 1862
	sbi 0x15,1
L414:
	.dbline 1863
;   if ((ch & 0x02) == 0x02) LCD_PORT |= LCD_D5;
	mov R24,R22
	andi R24,2
	cpi R24,2
	brne L416
X177:
	.dbline 1863
	sbi 0x15,2
L416:
	.dbline 1864
;   if ((ch & 0x01) == 0x01) LCD_PORT |= LCD_D4;
	mov R24,R22
	andi R24,1
	cpi R24,1
	brne L418
X178:
	.dbline 1864
	sbi 0x15,3
L418:
	.dbline 1865
;   if (rs == 1) LCD_PORT |= LCD_RS;
	cpi R20,1
	brne L420
X179:
	.dbline 1865
	sbi 0x15,6
L420:
	.dbline 1867
; 
;   LCD_PORT |= LCD_E;
	sbi 0x15,4
	.dbline 1868
;   LCD_PORT &= ~LCD_E;
	cbi 0x15,4
	.dbline -2
L401:
	.dbline 0 ; func end
	xjmp pop_xgsetF00C
	.dbsym r Stat 10 c
	.dbsym r ch 22 c
	.dbsym r rs 20 c
	.dbend
	.dbfunc e LCDReadData _LCDReadData fc
;           Byte -> R20
;             rs -> R16
	.even
_LCDReadData::
	st -y,R20
	st -y,R21
	.dbline -1
	.dbline 1885
; }
; 
; /******************************************************************************
; 
; Name:         ushort LCDRead(ushort rs)
; 
; Description:  read a byte in rs of the LCD 
; 
; Input:        rs -> Register select
; 
; Output:       ushort
; 
; Misc:     
; 
; ******************************************************************************/ 
; ushort LCDReadData(ushort rs)
; {
	.dbline 1886
;   ushort Byte=0;
	clr R20
	.dbline 1888
; 
;   LCD_DDR &= ~(LCD_D7 + LCD_D6 + LCD_D5 + LCD_D4);
	in R24,0x14
	andi R24,240
	out 0x14,R24
	.dbline 1890
; 
;   LCD_PORT = LCD_PIN & LCD_BACKLIGHT;
	in R24,0x13
	andi R24,128
	out 0x15,R24
	.dbline 1891
;   LCD_PORT |= LCD_RW;
	sbi 0x15,5
	.dbline 1892
;   if (rs == 1) LCD_PORT |= LCD_RS;
	cpi R16,1
	brne L423
X180:
	.dbline 1892
	sbi 0x15,6
L423:
	.dbline 1894
; 
;   LCD_PORT |= LCD_E;
	sbi 0x15,4
	.dbline 1895
;   LCD_PORT |= LCD_E;
	sbi 0x15,4
	.dbline 1896
;   if (LCD_PIN & LCD_D7) Byte |= 0x80;
	sbis 0x13,0
	rjmp L425
X181:
	.dbline 1896
	ori R20,128
L425:
	.dbline 1897
;   if (LCD_PIN & LCD_D6) Byte |= 0x40;
	sbis 0x13,1
	rjmp L427
X182:
	.dbline 1897
	ori R20,64
L427:
	.dbline 1898
;   if (LCD_PIN & LCD_D5) Byte |= 0x20;
	sbis 0x13,2
	rjmp L429
X183:
	.dbline 1898
	ori R20,32
L429:
	.dbline 1899
;   if (LCD_PIN & LCD_D4) Byte |= 0x10;
	sbis 0x13,3
	rjmp L431
X184:
	.dbline 1899
	ori R20,16
L431:
	.dbline 1900
;   LCD_PORT &= ~LCD_E;
	cbi 0x15,4
	.dbline 1902
; 
;   LCD_PORT |= LCD_E;
	sbi 0x15,4
	.dbline 1903
;   LCD_PORT |= LCD_E;
	sbi 0x15,4
	.dbline 1904
;   if (LCD_PIN & LCD_D7) Byte |= 0x08;
	sbis 0x13,0
	rjmp L433
X185:
	.dbline 1904
	ori R20,8
L433:
	.dbline 1905
;   if (LCD_PIN & LCD_D6) Byte |= 0x04;
	sbis 0x13,1
	rjmp L435
X186:
	.dbline 1905
	ori R20,4
L435:
	.dbline 1906
;   if (LCD_PIN & LCD_D5) Byte |= 0x02;
	sbis 0x13,2
	rjmp L437
X187:
	.dbline 1906
	ori R20,2
L437:
	.dbline 1907
;   if (LCD_PIN & LCD_D4) Byte |= 0x01;
	sbis 0x13,3
	rjmp L439
X188:
	.dbline 1907
	ori R20,1
L439:
	.dbline 1908
;   LCD_PORT &= ~LCD_E;
	cbi 0x15,4
	.dbline 1910
; 
;   LCD_PORT &= ~LCD_RW;
	cbi 0x15,5
	.dbline 1912
; 
;   LCD_DDR |= LCD_D7 + LCD_D6 + LCD_D5 + LCD_D4;
	in R24,0x14
	ori R24,15
	out 0x14,R24
	.dbline 1914
; 
;   return (Byte);
	mov R16,R20
	.dbline -2
L422:
	.dbline 0 ; func end
	ld R21,y+
	ld R20,y+
	ret
	.dbsym r Byte 20 c
	.dbsym r rs 16 c
	.dbend
	.dbfunc e LCDWait _LCDWait fV
	.even
_LCDWait::
	.dbline -1
	.dbline 1931
; }
; 
; /******************************************************************************
; 
; Name:         void LCDWait(void)
; 
; Description:  wait for the LCD to be ready
; 
; Input:        none
; 
; Output:       none
; 
; Misc:     
; 
; ******************************************************************************/
; void LCDWait(void)
; {
	xjmp L443
L442:
	.dbline 1932
;   while((LCDReadData(0) & 0x80) == 0x80) WDR();
	wdr
L443:
	.dbline 1932
	clr R16
	xcall _LCDReadData
	mov R24,R16
	andi R24,128
	cpi R24,128
	breq L442
X189:
	.dbline -2
L441:
	.dbline 0 ; func end
	ret
	.dbend
	.dbfunc e LCDDelay50us _LCDDelay50us fV
;              i -> R20,R21
;              j -> R22,R23
;          Delay -> R16,R17
	.even
_LCDDelay50us::
	xcall push_xgsetF000
	.dbline -1
	.dbline 1949
; }
; 
; /******************************************************************************
; 
; Name:         void LCDDelay50us(int Delay)
; 
; Description:  Delay of 50 us with a 1Mhz resonator
; 
; Input:        Delay X x 50us
; 
; Output:       none
; 
; Misc:
; 
; ******************************************************************************/
; void LCDDelay50us(int Delay)
; {
	.dbline 1952
;   int i,j;
; 
;   for (i=0;i<Delay;i++)
	clr R20
	clr R21
	xjmp L449
L446:
	.dbline 1953
;   {
	.dbline 1954
;     for (j=1;j<120;j++); 
	ldi R22,1
	ldi R23,0
L450:
	.dbline 1954
L451:
	.dbline 1954
	subi R22,255  ; offset = 1
	sbci R23,255
	.dbline 1954
	cpi R22,120
	ldi R30,0
	cpc R23,R30
	brlt L450
X190:
	.dbline 1955
;     asm("WDR");
	WDR
	.dbline 1956
;   }
L447:
	.dbline 1952
	subi R20,255  ; offset = 1
	sbci R21,255
L449:
	.dbline 1952
	cp R20,R16
	cpc R21,R17
	brlt L446
X191:
	.dbline -2
L445:
	.dbline 0 ; func end
	xjmp pop_xgsetF000
	.dbsym r i 20 I
	.dbsym r j 22 I
	.dbsym r Delay 16 I
	.dbend
	.dbfunc e LCDTextAttr _LCDTextAttr fV
;      attribute -> R10
	.even
_LCDTextAttr::
	xcall push_xgset300C
	mov R10,R16
	.dbline -1
	.dbline 1984
; }
; 
; /******************************************************************************
; 
; Name:         void LCDTextAttr(ushort Attribute)
; 
; Description:  Set the LCD attribute
; 
; Input:        LCD_C_BLINK_ON     : Cursor blink on
;               LCD_C_BLINK_OFF    : Cursor blink off
;               LCD_C_ON           : Cursor on
;               LCD_C_OFF          : Cursor off
;               LCD_DISPLAY_ON     : Display ON
;               LCD_DISPLAY_OFF    : Display OFF
;               LCD_BRIGHT_25      : VFD 25% Bright
;               LCD_BRIGHT_50      : VFD 50% Bright
;               LCD_BRIGHT_75      : VFD 75% Bright
;               LCD_BRIGHT_100     : VFD 100% Bright
;               LCD_BACK_LIGHT_ON  : Back Light ON
;               LCD_BACK_LIGHT_OFF : Back Light OFF
; 
; Output:       none
; 
; Misc:
; 
; ******************************************************************************/
; void LCDTextAttr(ushort attribute)
; {
	.dbline 1985
; switch (attribute)
	mov R20,R10
	clr R21
	cpi R20,32
	ldi R30,0
	cpc R21,R30
	brne X205
	xjmp L467
X205:
X192:
	cpi R20,33
	ldi R30,0
	cpc R21,R30
	brne X206
	xjmp L466
X206:
X193:
	cpi R20,34
	ldi R30,0
	cpc R21,R30
	brne X207
	xjmp L465
X207:
X194:
	cpi R20,35
	ldi R30,0
	cpc R21,R30
	brne X208
	xjmp L464
X208:
X195:
	cpi R20,36
	ldi R30,0
	cpc R21,R30
	brne X209
	xjmp L468
X209:
X196:
	cpi R20,37
	ldi R30,0
	cpc R21,R30
	brne X210
	xjmp L469
X210:
X197:
	ldi R24,37
	ldi R25,0
	cp R24,R20
	cpc R25,R21
	brlt L471
X198:
L470:
	cpi R20,9
	ldi R30,0
	cpc R21,R30
	breq L458
X199:
	cpi R20,10
	ldi R30,0
	cpc R21,R30
	breq L460
X200:
	cpi R20,12
	ldi R30,0
	cpc R21,R30
	breq L462
X201:
	xjmp L455
L471:
	cpi R20,251
	ldi R30,0
	cpc R21,R30
	brne X211
	xjmp L463
X211:
X202:
	cpi R20,253
	ldi R30,0
	cpc R21,R30
	breq L461
X203:
	cpi R20,254
	ldi R30,0
	cpc R21,R30
	breq L459
X204:
	xjmp L455
L458:
	.dbline 1988
;     {
;     case LCD_C_BLINK_ON:
;          LCDStat |= LCD_C_BLINK_ON;
	lds R24,_LCDStat
	ori R24,9
	sts _LCDStat,R24
	.dbline 1989
;          LCDWriteData(LCD_CTRL,LCDStat);
	mov R18,R24
	clr R16
	xcall _LCDWriteData
	.dbline 1990
;          break;
	xjmp L456
L459:
	.dbline 1993
;          
;     case LCD_C_BLINK_OFF:
;          LCDStat &= LCD_C_BLINK_OFF;
	lds R24,_LCDStat
	andi R24,254
	sts _LCDStat,R24
	.dbline 1994
;          LCDWriteData(LCD_CTRL,LCDStat);
	mov R18,R24
	clr R16
	xcall _LCDWriteData
	.dbline 1995
;          break;
	xjmp L456
L460:
	.dbline 1998
;          
;     case LCD_C_ON:
;          LCDStat |= LCD_C_ON;
	lds R24,_LCDStat
	ori R24,10
	sts _LCDStat,R24
	.dbline 1999
;          LCDWriteData(LCD_CTRL,LCDStat);
	mov R18,R24
	clr R16
	xcall _LCDWriteData
	.dbline 2000
;          break;
	xjmp L456
L461:
	.dbline 2003
;          
;     case LCD_C_OFF:
;          LCDStat &= LCD_C_OFF;
	lds R24,_LCDStat
	andi R24,253
	sts _LCDStat,R24
	.dbline 2004
;          LCDWriteData(LCD_CTRL,LCDStat);
	mov R18,R24
	clr R16
	xcall _LCDWriteData
	.dbline 2005
;          break;
	xjmp L456
L462:
	.dbline 2008
;          
;     case LCD_DISPLAY_ON:
;          LCDStat |= LCD_DISPLAY_ON;
	lds R24,_LCDStat
	ori R24,12
	sts _LCDStat,R24
	.dbline 2009
;          LCDWriteData(LCD_CTRL,LCDStat);
	mov R18,R24
	clr R16
	xcall _LCDWriteData
	.dbline 2010
;          break;
	xjmp L456
L463:
	.dbline 2013
;          
;     case LCD_DISPLAY_OFF:
;          LCDStat &= LCD_DISPLAY_OFF;
	lds R24,_LCDStat
	andi R24,251
	sts _LCDStat,R24
	.dbline 2014
;          LCDWriteData(LCD_CTRL,LCDStat);
	mov R18,R24
	clr R16
	xcall _LCDWriteData
	.dbline 2015
;          break;
	xjmp L456
L464:
	.dbline 2018
;          
;     case LCD_BRIGHT_25:
;          LCDWriteData(LCD_CTRL,0x20);
	ldi R18,32
	clr R16
	xcall _LCDWriteData
	.dbline 2019
;          LCDWriteData(LCD_DATA,0x03);
	ldi R18,3
	ldi R16,1
	xcall _LCDWriteData
	.dbline 2020
;          break;
	xjmp L456
L465:
	.dbline 2023
;          
;     case LCD_BRIGHT_50:
;          LCDWriteData(LCD_CTRL,0x20);
	ldi R18,32
	clr R16
	xcall _LCDWriteData
	.dbline 2024
;          LCDWriteData(LCD_DATA,0x02);
	ldi R18,2
	ldi R16,1
	xcall _LCDWriteData
	.dbline 2025
;          break;
	xjmp L456
L466:
	.dbline 2028
;          
;     case LCD_BRIGHT_75:
;          LCDWriteData(LCD_CTRL,0x20);
	ldi R18,32
	clr R16
	xcall _LCDWriteData
	.dbline 2029
;          LCDWriteData(LCD_DATA,0x01);
	ldi R18,1
	ldi R16,1
	xcall _LCDWriteData
	.dbline 2030
;          break;
	xjmp L456
L467:
	.dbline 2033
;          
;     case LCD_BRIGHT_100:
;          LCDWriteData(LCD_CTRL,0x20);
	ldi R18,32
	clr R16
	xcall _LCDWriteData
	.dbline 2034
;          LCDWriteData(LCD_DATA,0x00);
	clr R18
	ldi R16,1
	xcall _LCDWriteData
	.dbline 2035
;          break;    
	xjmp L456
L468:
	.dbline 2038
;               
;     case LCD_BACKLIGHT_ON:
;          LCD_PORT |= LCD_BACKLIGHT;
	sbi 0x15,7
	.dbline 2039
;          break;
	xjmp L456
L469:
	.dbline 2042
;          
;     case LCD_BACKLIGHT_OFF:
;          LCD_PORT &= ~(LCD_BACKLIGHT);
	cbi 0x15,7
	.dbline 2043
;          break;          
L455:
L456:
	.dbline -2
L454:
	.dbline 0 ; func end
	xjmp pop_xgset300C
	.dbsym r attribute 10 c
	.dbend
	.dbfunc e LCDInit _LCDInit fV
;              Y -> R20
;              X -> R10
	.even
_LCDInit::
	xcall push_xgset300C
	mov R20,R18
	mov R10,R16
	.dbline -1
	.dbline 2062
;     }
; }
; 
; /******************************************************************************
; 
; Name:         void LCDOn(ushort X, ushort Y)
; 
; Description:  Initialize LCD in 4bit mode
; 
; Input:        ushort X -> X size
;               ushort Y -> Y size
; 
; Output:       none
; 
; Misc:
; 
; ******************************************************************************/
; void LCDInit(ushort X, ushort Y)
; {
	.dbline 2063
;   MaxX = X;
	sts _MaxX,R10
	.dbline 2064
;   MaxY = Y;
	sts _MaxY,R20
	.dbline 2065
;   LCDStat = 0x0c;
	ldi R24,12
	sts _LCDStat,R24
	.dbline 2066
;   LCD_PORT = 0x00;
	clr R2
	out 0x15,R2
	.dbline 2067
;   LCD_DDR = LCD_D7+LCD_D6+LCD_D5+LCD_D4+LCD_E+LCD_RS+LCD_RW+LCD_BACKLIGHT;
	ldi R24,255
	out 0x14,R24
	.dbline 2068
;   LCD_PORT = ~(LCD_D7+LCD_D6+LCD_D5+LCD_D4+LCD_E+LCD_RS+LCD_RW);
	ldi R24,128
	out 0x15,R24
	.dbline 2069
;   LCD_PORT |= LCD_BACKLIGHT;
	sbi 0x15,7
	.dbline 2070
;   LCDDelay50us(340);
	ldi R16,340
	ldi R17,1
	xcall _LCDDelay50us
	.dbline 2072
; 
;   LCD_PORT = (LCD_D5 + LCD_D4 + LCD_BACKLIGHT);  
	ldi R24,140
	out 0x15,R24
	.dbline 2073
;   LCD_PORT |= LCD_E;
	sbi 0x15,4
	.dbline 2074
;   LCD_PORT &= ~LCD_E;
	cbi 0x15,4
	.dbline 2075
;   LCDDelay50us(100);
	ldi R16,100
	ldi R17,0
	xcall _LCDDelay50us
	.dbline 2076
;   LCD_PORT |= LCD_E;
	sbi 0x15,4
	.dbline 2077
;   LCD_PORT &= ~LCD_E;
	cbi 0x15,4
	.dbline 2078
;   LCDDelay50us(100);
	ldi R16,100
	ldi R17,0
	xcall _LCDDelay50us
	.dbline 2079
;   LCD_PORT |= LCD_E;
	sbi 0x15,4
	.dbline 2080
;   LCD_PORT &= ~LCD_E;
	cbi 0x15,4
	.dbline 2081
;   LCDDelay50us(100);
	ldi R16,100
	ldi R17,0
	xcall _LCDDelay50us
	.dbline 2083
; 
;   LCD_PORT = (LCD_D5 + LCD_BACKLIGHT);  
	ldi R24,132
	out 0x15,R24
	.dbline 2084
;   LCD_PORT |= LCD_E;
	sbi 0x15,4
	.dbline 2085
;   LCD_PORT &= ~LCD_E;
	cbi 0x15,4
	.dbline 2086
;   LCDDelay50us(100);
	ldi R16,100
	ldi R17,0
	xcall _LCDDelay50us
	.dbline 2088
; 
;   if (Y == 1) LCDWriteData(LCD_CTRL,0x20);    // 1 line
	cpi R20,1
	brne L473
X212:
	.dbline 2088
	ldi R18,32
	clr R16
	xcall _LCDWriteData
	xjmp L474
L473:
	.dbline 2089
;   else LCDWriteData(LCD_CTRL,0x28);           // 2 line
	ldi R18,40
	clr R16
	xcall _LCDWriteData
L474:
	.dbline 2091
; 
;   LCDWriteData(LCD_CTRL,0x0c);                // Disp ON-Cur OFF-Blink OFF
	ldi R18,12
	clr R16
	xcall _LCDWriteData
	.dbline 2092
;   LCDWriteData(LCD_CTRL,0x01);                // Clear display
	ldi R18,1
	clr R16
	xcall _LCDWriteData
	.dbline 2093
;   LCDDelay50us(50);
	ldi R16,50
	ldi R17,0
	xcall _LCDDelay50us
	.dbline 2094
;   LCDWriteData(LCD_CTRL,0x06);                // Cursor INC Shift OFF
	ldi R18,6
	clr R16
	xcall _LCDWriteData
	.dbline 2096
; 
;   DDRD |= 0x80;
	sbi 0x11,7
	.dbline 2097
;   TCCR2 = 0x79;
	ldi R24,121
	out 0x25,R24
	.dbline 2098
;   OCR2 = 0xff;
	ldi R24,255
	out 0x23,R24
	.dbline -2
L472:
	.dbline 0 ; func end
	xjmp pop_xgset300C
	.dbsym r Y 20 c
	.dbsym r X 10 c
	.dbend
	.dbfunc e LCDContrast _LCDContrast fV
;           Cont -> R16
	.even
_LCDContrast::
	.dbline -1
	.dbline 2115
; }
; 
; /******************************************************************************
; 
; Name:         void LCDContrast(ushort Cont)
; 
; Description:  Set the LCD Contrast
; 
; Input:        from 0 to 255
; 
; Output:       none
; 
; Misc:
; 
; ******************************************************************************/
; void LCDContrast(ushort Cont)
; {
	.dbline 2116
;   OCR2 = Cont;
	out 0x23,R16
	.dbline -2
L475:
	.dbline 0 ; func end
	ret
	.dbsym r Cont 16 c
	.dbend
	.dbfunc e LCDOff _LCDOff fV
	.even
_LCDOff::
	.dbline -1
	.dbline 2133
; }
; 
; /******************************************************************************
; 
; Name:         void LCDOff(void)
; 
; Description:  Shut down LCD
; 
; Input:        none
; 
; Output:       none
; 
; Misc:
; 
; ******************************************************************************/
; void LCDOff(void)
; {
	.dbline 2134
;  LCD_DDR = 0xff;
	ldi R24,255
	out 0x14,R24
	.dbline 2135
;  LCD_PORT = 0x00; 
	clr R2
	out 0x15,R2
	.dbline 2136
;  DDRD &= ~0x80;
	cbi 0x11,7
	.dbline -2
L476:
	.dbline 0 ; func end
	ret
	.dbend
	.dbfunc e KeyInit _KeyInit fV
	.even
_KeyInit::
	.dbline -1
	.dbline 2157
; }
; 
; //*****************************************************************************
; // Key Code
; //*****************************************************************************
; 
; /******************************************************************************
; 
; Name:         void KeyInit(void)
; 
; Description:  Initialize IO's
; 
; Input:        none
; 
; Output:       none
; 
; Misc:
; 
; ******************************************************************************/
; void KeyInit(void)
; {
	.dbline 2158
;   KEY_DDR |= ROW4 | ROW3 | ROW2 | ROW1;    // Row as output
	in R24,0x17
	ori R24,30
	out 0x17,R24
	.dbline 2159
;   KEY_DDR &= ~(COL4 | COL3 | COL2 | COL1); // Col as input
	in R24,0x17
	andi R24,31
	out 0x17,R24
	.dbline 2160
;   KEY_PORT |= COL4 | COL3 | COL2 | COL1;   // Col with pull up  
	in R24,0x18
	ori R24,224
	out 0x18,R24
	.dbline -2
L477:
	.dbline 0 ; func end
	ret
	.dbend
	.dbfunc e KeyLook _KeyLook fc
;            Val -> R16
;              i -> R18
	.even
_KeyLook::
	.dbline -1
	.dbline 2177
; }
; 
; /******************************************************************************
; 
; Name:         void KeyScan(void)
; 
; Description:  ScanKeyPad
; 
; Input:        none
; 
; Output:       none
; 
; Misc:
; 
; ******************************************************************************/
; ushort KeyLook(void)
; {
	.dbline 2180
;   ushort Val,i;
;   
;   Val = 0xff;
	ldi R16,255
	.dbline 2182
;   
;   KEY_PORT &= ~ROW1;
	cbi 0x18,1
	.dbline 2183
;   for (i=0;i<255;i++) WDR();
	clr R18
	xjmp L482
L479:
	.dbline 2183
	wdr
L480:
	.dbline 2183
	inc R18
L482:
	.dbline 2183
	cpi R18,255
	brlo L479
X213:
	.dbline 2184
;   if (!(KEY_PIN & COL1)) Val = 1;
	sbic 0x16,5
	rjmp L483
X214:
	.dbline 2184
	ldi R16,1
L483:
	.dbline 2185
;   if (!(KEY_PIN & COL2)) Val = 2;
	sbic 0x16,6
	rjmp L485
X215:
	.dbline 2185
	ldi R16,2
L485:
	.dbline 2186
;   if (!(KEY_PIN & COL3)) Val = 3;
	sbic 0x16,7
	rjmp L487
X216:
	.dbline 2186
	ldi R16,3
L487:
	.dbline 2187
;   KEY_PORT |= ROW1;
	sbi 0x18,1
	.dbline 2189
; 
;   KEY_PORT &= ~ROW2;
	cbi 0x18,2
	.dbline 2190
;   for (i=0;i<255;i++) WDR();
	clr R18
	xjmp L492
L489:
	.dbline 2190
	wdr
L490:
	.dbline 2190
	inc R18
L492:
	.dbline 2190
	cpi R18,255
	brlo L489
X217:
	.dbline 2191
;   if (!(KEY_PIN & COL1)) Val = 4;
	sbic 0x16,5
	rjmp L493
X218:
	.dbline 2191
	ldi R16,4
L493:
	.dbline 2192
;   if (!(KEY_PIN & COL2)) Val = 5;
	sbic 0x16,6
	rjmp L495
X219:
	.dbline 2192
	ldi R16,5
L495:
	.dbline 2193
;   if (!(KEY_PIN & COL3)) Val = 6;
	sbic 0x16,7
	rjmp L497
X220:
	.dbline 2193
	ldi R16,6
L497:
	.dbline 2194
;   KEY_PORT |= ROW2;
	sbi 0x18,2
	.dbline 2196
; 
;   KEY_PORT &= ~ROW3;
	cbi 0x18,3
	.dbline 2197
;   for (i=0;i<255;i++) WDR();
	clr R18
	xjmp L502
L499:
	.dbline 2197
	wdr
L500:
	.dbline 2197
	inc R18
L502:
	.dbline 2197
	cpi R18,255
	brlo L499
X221:
	.dbline 2198
;   if (!(KEY_PIN & COL1)) Val = 7;
	sbic 0x16,5
	rjmp L503
X222:
	.dbline 2198
	ldi R16,7
L503:
	.dbline 2199
;   if (!(KEY_PIN & COL2)) Val = 8;
	sbic 0x16,6
	rjmp L505
X223:
	.dbline 2199
	ldi R16,8
L505:
	.dbline 2200
;   if (!(KEY_PIN & COL3)) Val = 9;
	sbic 0x16,7
	rjmp L507
X224:
	.dbline 2200
	ldi R16,9
L507:
	.dbline 2201
;   KEY_PORT |= ROW3;
	sbi 0x18,3
	.dbline 2203
;   
;   KEY_PORT &= ~ROW4;
	cbi 0x18,4
	.dbline 2204
;   for (i=0;i<255;i++) WDR();
	clr R18
	xjmp L512
L509:
	.dbline 2204
	wdr
L510:
	.dbline 2204
	inc R18
L512:
	.dbline 2204
	cpi R18,255
	brlo L509
X225:
	.dbline 2205
;   if (!(KEY_PIN & COL1)) Val = 10;
	sbic 0x16,5
	rjmp L513
X226:
	.dbline 2205
	ldi R16,10
L513:
	.dbline 2206
;   if (!(KEY_PIN & COL2)) Val = 0;
	sbic 0x16,6
	rjmp L515
X227:
	.dbline 2206
	clr R16
L515:
	.dbline 2207
;   if (!(KEY_PIN & COL3)) Val = 11;
	sbic 0x16,7
	rjmp L517
X228:
	.dbline 2207
	ldi R16,11
L517:
	.dbline 2208
;   if (!(KEY_PIN & (COL1 | COL3))) Val = 20;
	in R24,0x16
	andi R24,160
	brne L519
X229:
	.dbline 2208
	ldi R16,20
L519:
	.dbline 2209
;   KEY_PORT |= ROW4;
	sbi 0x18,4
	.dbline 2211
;   
;   return Val;
	.dbline -2
L478:
	.dbline 0 ; func end
	ret
	.dbsym r Val 16 c
	.dbsym r i 18 c
	.dbend
	.area bss(ram, con, rel)
	.dbfile C:\DATA\InterComm\CODENE~1\InterComm.c
L522:
	.blkb 1
	.area text(rom, con, rel)
	.dbfile C:\DATA\InterComm\CODENE~1\InterComm.c
	.dbfunc e KeyScan _KeyScan fV
	.dbsym s LastKey L522 c
;        KeyRead -> R20
	.even
_KeyScan::
	st -y,R20
	st -y,R21
	.dbline -1
	.dbline 2228
; }
; 
; /******************************************************************************
; 
; Name:         void KeyScan(void)
; 
; Description:  ScanKeyPad
; 
; Input:        none
; 
; Output:       none
; 
; Misc:
; 
; ******************************************************************************/
; void KeyScan(void)
; {
	.dbline 2232
;   static unsigned char LastKey;
;   unsigned char KeyRead;
; 
;   KeyRead = KeyLook();
	xcall _KeyLook
	mov R20,R16
	.dbline 2234
; 
;   if ((KeyRead != LastKey) && (KeyRead != 0xff))
	lds R2,L522
	cp R16,R2
	breq L523
X230:
	cpi R16,255
	breq L523
X231:
	.dbline 2235
;   {
	.dbline 2236
;     Key = KeyRead;
	sts _Key,R20
	.dbline 2237
;     if (KeySound)
	lds R2,_KeySound
	tst R2
	breq L525
X232:
	.dbline 2238
;     {
	.dbline 2239
;       Tone = KeySoundTone;
	lds R2,_KeySoundTone
	sts _Tone,R2
	.dbline 2240
;       VoiceVolume((KeySoundVolume*2)+55);
	lds R2,_KeySoundVolume
	ldi R24,2
	mul R24,R2
	mov R16,R0
	subi R16,201    ; addi 55
	xcall _VoiceVolume
	.dbline 2241
;       InterCommMode = TONE;
	ldi R24,3
	sts _InterCommMode,R24
	.dbline 2242
;       Delay(KeySoundLen);
	lds R16,_KeySoundLen
	xcall _Delay
	.dbline 2243
;       InterCommMode = OFF;
	clr R2
	sts _InterCommMode,R2
	.dbline 2244
;       VoiceVolume(0);
	clr R16
	xcall _VoiceVolume
	.dbline 2245
;     }
L525:
	.dbline 2246
;   }
L523:
	.dbline 2247
;   LastKey = KeyRead;
	sts L522,R20
	.dbline -2
L521:
	.dbline 0 ; func end
	ld R21,y+
	ld R20,y+
	ret
	.dbsym r KeyRead 20 c
	.dbend
	.area bss(ram, con, rel)
	.dbfile C:\DATA\InterComm\CODENE~1\InterComm.c
_RefreshDisplay::
	.blkb 1
	.dbsym e RefreshDisplay _RefreshDisplay c
_BroadCastEnable::
	.blkb 1
	.dbsym e BroadCastEnable _BroadCastEnable c
_IncommingCall::
	.blkb 1
	.dbsym e IncommingCall _IncommingCall c
_InterCommMode::
	.blkb 1
	.dbsym e InterCommMode _InterCommMode c
_DataOutBufferQte::
	.blkb 2
	.dbsym e DataOutBufferQte _DataOutBufferQte i
_DataOutBufferRead::
	.blkb 2
	.dbsym e DataOutBufferRead _DataOutBufferRead pc
_DataOutBufferWrite::
	.blkb 2
	.dbsym e DataOutBufferWrite _DataOutBufferWrite pc
_DataOutBuffer::
	.blkb 64
	.dbsym e DataOutBuffer _DataOutBuffer A[64:64]c
_DataInBufferQte::
	.blkb 2
	.dbsym e DataInBufferQte _DataInBufferQte i
_DataInBufferRead::
	.blkb 2
	.dbsym e DataInBufferRead _DataInBufferRead pc
_DataInBufferWrite::
	.blkb 2
	.dbsym e DataInBufferWrite _DataInBufferWrite pc
_DataInBuffer::
	.blkb 64
	.dbsym e DataInBuffer _DataInBuffer A[64:64]c
_NetAddress::
	.blkb 1
	.dbsym e NetAddress _NetAddress c
_KeySoundLen::
	.blkb 1
	.dbsym e KeySoundLen _KeySoundLen c
_KeySoundTone::
	.blkb 1
	.dbsym e KeySoundTone _KeySoundTone c
_KeySoundVolume::
	.blkb 1
	.dbsym e KeySoundVolume _KeySoundVolume c
_KeySound::
	.blkb 1
	.dbsym e KeySound _KeySound c
_Key::
	.blkb 1
	.dbsym e Key _Key c
_Text::
	.blkb 20
	.dbsym e Text _Text A[20:20]c
_LCDStat::
	.blkb 1
	.dbsym e LCDStat _LCDStat c
_MaxY::
	.blkb 1
	.dbsym e MaxY _MaxY c
_MaxX::
	.blkb 1
	.dbsym e MaxX _MaxX c
	.area lit(rom, con, rel)
L242:
	.byte 45,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45
	.byte 45,45,45,45,0,0
L229:
	.byte 32,32,32,35,45,62,'T,'a,'l,'k,32,42,45,62,'E,'n
	.byte 'd,32,32,32,0,0
L228:
	.byte 32,32,32,'B,'r,'o,'a,'d,'C,'a,'s,'t,32,'C,'a,'l
	.byte 'l,32,32,32,0,0
L219:
	.byte 35,45,62,'T,'a,'l,'k,32,42,45,62,'E,'n,'d,32,32
	.byte 32,32,32,32,0,0
L218:
	.byte 'C,'a,'l,'l,'i,'n,'g,32,'S,'t,'a,'t,'i,'o,'n,32
	.byte 58,35,37,'d,0,0
L207:
	.byte 'N,'e,'w,32,'A,'d,'r,40,48,48,45,51,57,41,32,58
	.byte 32,48,48,0,0
L206:
	.byte 'C,'u,'r,'r,'e,'n,'t,32,'A,'d,'d,'r,'e,'s,'s,32
	.byte 58,32,37,'d,0,0
L190:
	.byte 'B,'r,'o,'a,'d,'C,'a,'s,'t,32,'i,'s,32,'O,'F,'F
	.byte 32,32,32,32,0,0
L189:
	.byte 'B,'r,'o,'a,'d,'C,'a,'s,'t,32,'i,'s,32,'O,'N,32
	.byte 32,32,32,32,0,0
L174:
	.byte 42,32,'T,'o,32,'T,'o,'g,'g,'l,'e,32,32,35,45,62
	.byte 'S,'a,'v,'e,0,0
L173:
	.byte 'K,'e,'y,32,'S,'o,'u,'n,'d,32,'i,'s,32,'O,'F,'F
	.byte 32,32,32,32,0,0
L172:
	.byte 'K,'e,'y,32,'S,'o,'u,'n,'d,32,'i,'s,32,'O,'N,32
	.byte 32,32,32,32,0,0
L161:
	.byte 'N,'e,'w,32,'K,'e,'y,32,'V,'o,'l,32,48,48,45,57
	.byte 57,58,48,48,0,0
L160:
	.byte 'C,'u,'r,'r,'e,'n,'t,32,'K,'e,'y,32,'V,'o,'l,58
	.byte 37,'d,0,0
L144:
	.byte 'N,'e,'w,32,'T,'o,'n,'e,40,48,48,45,53,57,41,58
	.byte 48,48,0,0
L139:
	.byte 32,45,45,45,45,45,45,45,45,45,45,45,45,45,45,45
	.byte 45,45,45,32,0,0
L138:
	.byte 32,'V,'a,'l,'u,'e,32,'O,'u,'t,32,'O,'f,32,'R,'a
	.byte 'n,'g,'e,32,0,0
L137:
	.byte 32,32,45,45,45,45,45,45,45,45,45,45,45,45,45,45
	.byte 45,32,32,32,0,0
L136:
	.byte 32,32,'N,'e,'w,32,'V,'a,'l,'u,'e,32,'S,'a,'v,'e
	.byte 'd,32,32,32,0,0
L124:
	.byte 'N,'e,'w,32,'T,'o,'n,'e,40,48,48,45,49,48,41,58
	.byte 48,48,0,0
L123:
	.byte 'C,'u,'r,'r,'e,'n,'t,32,'T,'o,'n,'e,32,58,32,37
	.byte 'd,0,0
L118:
	.byte 32,45,45,'I,'n,'c,'o,'m,'m,'i,'n,'g,32,'C,'a,'l
	.byte 'l,45,45,32,0,0
L115:
	.byte 32,45,45,32,32,'P,'l,'e,'a,'s,'e,32,'W,'a,'i,'t
	.byte 32,45,45,32,0,0
L114:
	.byte 32,45,45,32,32,32,32,'B,32,'u,32,'s,32,'y,32,32
	.byte 32,45,45,32,0,0
L111:
	.byte 'C,'o,'m,'m,'u,'n,'i,'c,'a,'t,'i,'o,'n,32,'e,'n
	.byte 'd,'e,'d,32,0,0
L79:
	.byte 45,62,32,32,32,32,32,32,32,32,32,32,32,32,32,32
	.byte 32,32,0,0
L76:
	.byte 45,62,'R,'e,'s,'e,'t,32,'S,'t,'a,'t,'i,'o,'n,32
	.byte 35,32,0,0
L73:
	.byte 45,62,'S,'e,'t,32,'B,'r,'o,'a,'d,'C,'a,'s,'t,32
	.byte 35,32,0,0
L70:
	.byte 45,62,'S,'e,'t,32,'T,'o,'n,'e,32,'L,'e,'n,32,35
	.byte 32,0,0
L67:
	.byte 45,62,'S,'e,'t,32,'K,'e,'y,32,'V,'o,'l,'u,'m,'e
	.byte 32,35,0,0
L64:
	.byte 45,62,'S,'e,'t,32,'K,'e,'y,32,'T,'o,'n,'e,32,35
	.byte 32,0,32,0
L61:
	.byte 45,62,'S,'e,'t,32,'K,'e,'y,32,'S,'o,'u,'n,'d,32
	.byte 35,32,0,0
L58:
	.byte 45,62,'S,'e,'t,32,'A,'d,'d,'r,'e,'s,'s,32,35,32
	.byte 32,32,0,0
L55:
	.byte 45,62,'S,'e,'n,'d,32,'R,'e,'l,'e,'a,'s,'e,32,35
	.byte 32,32,0,0
L52:
	.byte 45,62,'C,'a,'l,'l,'i,'n,'g,32,35,32,32,32,32,32
	.byte 32,32,0,0
L49:
	.byte 45,62,'B,'r,'o,'a,'d,'c,'a,'s,'t,32,'C,'a,'l,'l
	.byte 32,35,0,0
L42:
	.byte 32,32,'I,'n,'t,'e,'r,'C,'o,'m,'m,32,32,'V,58,50
	.byte 46,49,0,0
L32:
	.byte 32,32,32,32,'V,'o,'l,'u,'m,'e,32,58,37,'d,32,32
	.byte 0,0
L31:
	.byte 32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32
	.byte 32,32,32,32,0,0
; }
